/*** alloc.c
        malloc data
        for m-compiler
      03.12.02
 ****/
#define  ALLOC_C

#include "lisp.h"
extern Uchar *alloc_space(ptr ,Uint);

extern ptr k_q;

void check_alloc(ptr x){
  if(SREGP(x)||!MALLOCP(x)) error(E_notalloc,x);
}

ptr  *get_alloc(Reg ptr mal,int *len){
     ptr q;
   //  org *len=(long)CDR(mal);
   *len=GETNUM(CDR(mal));
   q=CAR(mal);
   //  org q++;
   return(ptr *)q;
}

/***   MALLOC  (ptr-vector . size)    ***/
ptr make_alloc(int i){  /**** i is vector size  ***/
 int n;
      ptr c;
     ptr *p;
       c=new_cell(MALLOC);
      
       /**  org CDR(c)=(ptr)(long) i;  ** for gbc Caution!  ***/
       CDR(c)=MAKESINT(i); /*** for gbc   ***/
    psh(c);
    /***CAR(c)=(ptr)-1; * psh & car=-1(SEOF) needs !!! because Mymalloc may call gbc!  ***/
   /** p=(ptr *)Mymalloc( i*sizeof(ptr));  ** bind with next is error 64bit compiler ***/
   //CAR(c)=(ptr)p; 
    p=(ptr *)alloc_space(c,i*sizeof(ptr));  //  CAR(c) is set and safe for gbc
      while(i--){
            *p=a_f; /***  init  #f ***/ 
           p++;
      }
   pull();
   return c;
  }

/*** for string data or pure biinary   **/
/**** MALLOC_BIN  (myalloc  .  size)   ***/
ptr make_alloc_bin(int i){
 int n;
      ptr c;
       c=new_cell(MALLOC|MALLOC_BIN);
       CDR(c)=MAKESINT(i);/*** for gbc   ***/
       //CAR(c)=(ptr)(long)-1;
    psh(c);
    /*** CAR(c)=(ptr)Mymalloc( i);  ** ptr *  in real ***/
    alloc_space(c,i);  //  CAR(c) is set and safe for gbc
    pull();
   return c;
  }


ptr s_alloc(int narg,ptr env){
   ptr s ;
       checknarg(narg-1);
    s=*(stack-1);
   return make_alloc(GETNUM(s));
}

static ptr alloc_ref(ptr mal,int n){
  Reg  ptr *p ;
  int m;
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,MAKESINT(n));
   return *(p+n);
}

static ptr alloc_set(ptr mal,int n,ptr val){
   Reg ptr *p ;
  int m;
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,MAKESINT(n));
    *(p+n)=val;
  return a_undef;
}

  
ptr s_alloc_ref(int narg,ptr env){
  Reg  ptr mal,*p ;
  int n,m;
    mal=*(stack-2);
   n= GETNUM(*(stack-1));
   checknarg(narg-2);
   check_alloc(mal);
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,*(stack-1));
   return *(p+n);
}

ptr s_alloc_set(int narg,ptr env){
   Reg ptr mal,*p ,val;
  int n,m;
    mal=*(stack-3);
   n= GETNUM(*(stack-2));
    val=*(stack-1);
   checknarg(narg-3);
   check_alloc(mal);
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,*(stack-2));
    *(p+n)=val;
  return a_undef;
}  

ptr s_alloc_length(Reg int narg,ptr env)
      /* (vector x1 x2 ....) */
{
   Reg ptr x;
    int n;
    checknarg(narg-1);
    x=*(stack-1);
   check_alloc(x);
    get_alloc(x,&n);
    return MAKESINT(n);
}

      /* (alloc-copy  x  n  m)  n,m are start,end  */
ptr s_alloc_copy(Reg int narg,ptr env)
{
   Reg ptr x,*p,*q,y;
    int size,n,m;
      checknarg(narg-3);
    x=*(stack-3);
    /*** checkvect(x);   ***/
   check_alloc(x);
    p=get_alloc(x,&size);
       n=GETNUM(*(stack-2));
       m=GETNUM(*(stack-1));

    if(m>size) error(E_range,*(stack-1));
    m-=n;
    if(m<=0) error(E_range,*(stack-1));
    y=make_alloc(m);
    q=get_alloc(y,&size);
    p+=n;
    while(n--) {
        *q++=*p++;
    }
   return y;
}

ptr s_alloc_pred(Reg int narg,ptr env)
      /* (alloc?  x ) */
{
   Reg ptr x;
      checknarg(narg-1);
    x=*(stack-1);
  if(SREGP(x)||!MALLOCP(x)) return a_f;
   return a_t;
}


