/** bigmath.c
***/
#define  BIGMATH_C 

#include "lisp.h"
#include <stdio.h>

extern ptr abadd(),absub(),
     longinc(),genadd(),gensub(),
    longmul();

extern mpz_t mpzwork1,mpzwork2;
   
static ptr longcopy(p)
    Reg ptr p;   /*** big ***/
 {
    psh(p);
    p= mpz2bignum(BIGNUM(p));
    pull();    /***********!!!!   04.12.23 ***/
    return p;
}

ptr longadd(p,q)
   Reg ptr p,q;
 {
    /*  long add */
    psh(p);
    psh(q);
     mpz_add(mpzwork1,BIGNUM(p),BIGNUM(q));
     p= mpz_check16(mpzwork1);
     stack-=2;
     return p;
   }

 ptr longneg(q)
   Reg ptr q;
  {
   Reg ptr r;
    psh(q);
     r=longcopy(q);
    /*** mpz_ui_sub(BIGNUM(q),0,BIGNUM(q)); ***/
    mpz_neg(BIGNUM(r),BIGNUM(q));
     r= check16(r); /** need for only q=SINTMAX+1  **/
    pull();
    return r;
  }

 ptr longsub(p,q)
   Reg ptr p,q;
  {
      /** if(p==q) return ZERO; ***/ 
      psh(p);
      psh(q);
    
      mpz_sub(mpzwork1,BIGNUM(p),BIGNUM(q));
      p= mpz_check16(mpzwork1);
      stack-=2;
      return p;
  }

 ptr longmul(p,q)
   Reg ptr p,q;
  {
     psh(p);
     psh(q);

      mpz_mul(mpzwork1,BIGNUM(p),BIGNUM(q));
      p= mpz_check16(mpzwork1);
      stack-=2;
      return p;
  }

ptr long16mulsub(p,v)
   Reg ptr p;
   Reg int v;  /*  v is  28bit integer */
 {
   if(v==0) return ZERO;
   psh(p);
   mpz_mul_si(mpzwork1,BIGNUM(p),v);
   p= mpz2bignum(mpzwork1);
   pull();
   return p;
}

ptr longdiv(p,q)
   Reg ptr p,q;
  {
     psh(p);
     psh(q);

      mpz_fdiv_q(mpzwork1,BIGNUM(p),BIGNUM(q));
      p= mpz_check16(mpzwork1);
      stack-=2;
     return  p;
  }

ptr longmod(p,q)  
   Reg ptr p,q;
  {
      psh(p);
      psh(q);

      mpz_fdiv_r(mpzwork1,BIGNUM(p),BIGNUM(q));
      p=mpz_check16(mpzwork1);
      if(gsign(q)){
                if( gsign(p)) goto owa;
            }
           else if(!gsign(p)) goto owa;
        p= genadd(p,q);
      owa:
         stack-=2;
         return p;
  }

ptr longremain(p,q)
   Reg ptr p,q;
  {
    Reg ptr r;
      psh(p);
      psh(q);
      mpz_fdiv_r(mpzwork1,BIGNUM(p),BIGNUM(q));
      r=mpz_check16(mpzwork1);
      psh(r);
      if(gsign(p)){
                if( gsign(r)) goto owa;
                if(gsign(q)) {
                    r=genadd(r,q);
                    goto owa;
                  }
                else{
                    r= gensub(r,q);
                    goto owa;
                  }
            }
           else if(!gsign(r)) goto owa;
     if(gsign(q)){
                  r =gensub(r,q);
                  goto owa;
      }
           r= genadd(r,q);
  owa:
     stack-=3;
     return r;
  }

/* original
ptr longremain(p,q)  
   Reg ptr p,q;
  {
    Reg ptr r;
      mpz_fdiv_r(mpzwork1,BIGNUM(p),BIGNUM(q));
      r=mpz_check16(mpzwork1);
      if(gsign(p)){
                if( gsign(r)) return r;
                if(gsign(q)) return genadd(r,q);
                else
                    return gensub(r,q);
            }
           else if(!gsign(r)) return r;
          if(gsign(q)) return gensub(r,q);
           return genadd(r,q);
  } 
*/

ptr long16divsub(p,v)
   Reg ptr p;
   Reg int v;  /*  v is  28bit integer */
 {
   int sign=0;
   if(v<0){
         sign=1;
         v=-v;
    }
   psh(p);
   mpz_fdiv_q_ui(mpzwork1,BIGNUM(p),v);
   p=mpz_check16(mpzwork1);
   psh(p);
   if(sign)  p=minus(p);
   stack-=2;
   return p;
}

 ptr long16modsub(p,v)
   Reg ptr p;
   Reg int v;  /*  v is  28bit integer */
 {
   Reg ptr q;
   int sign=0;
   if(v<0){
         sign=1;
         v=-v;
    }
   psh(p);
   mpz_fdiv_r_ui(mpzwork1,BIGNUM(p),v);
   q=mpz_check16(mpzwork1);
   psh(q);
   if(sign){
                if( gsign(q)) goto owa;
            }
    else if(!gsign(q)) goto owa;
    if(sign) v=-v;
       q= genadd(q,MAKESINT(v));

owa:
   stack-=2;
   return q;
}

 ptr long16remain(p,v)
   Reg ptr p;
   Reg int v;  /*  v is  28bit integer */
 {  
   Reg ptr q;
   int sign=0;
   if(v<0){
         sign=1;
         v=-v;
    }
   psh(p);
   mpz_fdiv_r_ui(mpzwork1,BIGNUM(p),v);
   q=mpz_check16(mpzwork1);
   psh(q);
   if(gsign(p)){ 
                if( gsign(q)) goto owa;
                q=gensub(q,MAKESINT(v));
                goto owa;
            }
    else if(!gsign(q)) goto owa;
       q= genadd(q,MAKESINT(v));
owa:
    stack-=2;
    return q;
}     


 ptr longinc(v,p)
   Reg int v;  /*  v is  28bit integer */
   Reg ptr p;
{
  psh(p);
   mpz_add_ui(mpzwork1,BIGNUM(p),v);
   p= mpz_check16(mpzwork1);
  pull();
  return p;
}

 
