/***  complex.c 
***/
/*** 03.09.16  complex start in ss lisp 0.14 ***/
#define  COMPLEX_C

#include "lisp.h"

extern ptr _float(),genmul(),gendiv(),genadd(),gensub();

ptr norm2(ptr);
ptr complex(ptr,ptr);

ptr list_complex(list)
  Reg ptr list;
 {
  /***  sub of read #c( p q) ***/
  Reg ptr p,q;
  if(SREGP(list)) goto err;
  p=CAR(list);
  list=CDR(list);
  q=CAR(list);
  if(CDR(list)!=a_nil) goto err;
  return complex(p,q);  
  err: return error(E_typemis,p);
 }

ptr make_complex(p,q)
  Reg ptr p,q;
 {
  p=SCONS(p,q);
  ATTR(p)=COMPLEX;
  return p;
 }
 
ptr complex(p,q)
  Reg ptr p,q;
 {
  Reg int  a,b;
  if(!REALP(p))  goto err;
  if(!REALP(q))  goto err;
  p=SCONS(p,q);
  ATTR(p)=COMPLEX;
  return p;
  err: return error(E_typemis,p);
}

ptr _complex(p)
  Reg ptr p;
 {
  if(SINTP(p))
      return make_complex(p,ZERO);
  if(COMPLEXP(p))  return p;
  if(REALP(p))
   {
         return make_complex(p,ZERO);
   }
  return error(E_typemis,p);
 }

/***   -> pred.c
ptr s_complexp(int narg,ptr env)
 {
   Reg ptr x=*(stack-1);
   checknarg(narg-1);
   if(SREGP(x)) return a_f;
   return PRED(COMPLEXP(x));
 }
***/
   
ptr s_complex(int narg,ptr env)
  
 {
   Reg ptr x;
   checknarg(narg-2);
   x=*(stack-2);
   return complex(x,*(stack-1));
 }
ptr s_realpart(int narg,ptr env)
  
 {
  Reg ptr p=*(stack-1);
   checknarg(narg-1);
  if(REALP(p))  return p;
  if(COMPLEXP(p))  return CAR(p);
 return error(E_typemis,p);
 }

ptr s_imagpart(int narg,ptr env)
  
 {
  Reg ptr p=*(stack-1);
   checknarg(narg-1);
  if(REALP(p))  
     {
       if(INTEGERP(p)||RATIOP(p))
           return ZERO;
       return _float(ZERO);
     }
  if(COMPLEXP(p))  return CDR(p);
 return error(E_typemis,p);
 }
     
/*** sub of genmath.c ***/
ptr complexadd(p,q)
  Reg ptr p,q;
 {
  Reg ptr x,y;
   psh(p);
   psh(q);
   psh(x=genadd(CAR(p),CAR(q)));
   y=genadd(CDR(p),CDR(q));
   sp_pull(3);
   return complex(x,y);
 }
ptr complexsub(p,q)
  Reg ptr p,q;
 {
  Reg ptr x,y;
   psh(p);
   psh(q);
   psh(x=gensub(CAR(p),CAR(q)));
   y=gensub(CDR(p),CDR(q));
   sp_pull(3);
   return complex(x,y);
 }   
ptr complexmul(p,q)
  Reg ptr p,q;
 {
  Reg ptr x,y,u;
   psh(p);
   psh(q);
   psh(x=genmul(CAR(p),CAR(q)));
   psh(y=genmul(CDR(p),CDR(q)));
   psh(u=gensub(x,y));
   *(l_sp-3)=x=genmul(CAR(p),CDR(q));
   *(l_sp-2)=y=genmul(CDR(p),CAR(q));
   y=genadd(x,y);
   sp_pull(5);
   return complex(u,y);
 }   
ptr complexdiv(p,q)
  Reg ptr p,q;
 {
  Reg ptr x,y,u,norm;
   psh(p);
   psh(q);
   psh(norm=norm2(q));
   psh(x=genmul(CAR(p),CAR(q)));
   psh(y=genmul(CDR(p),CDR(q)));
   psh(u=genadd(x,y));
   *(l_sp-3)=x=genmul(CAR(p),CDR(q));
   *(l_sp-2)=y=genmul(CDR(p),CAR(q));
   *(l_sp-2)=y=gensub(y,x);
   *(l_sp-2)=y=gendiv(y,norm);
   *(l_sp-1)=u=gendiv(u,norm);
   sp_pull(6);
   return complex(u,y);
 }   
    
ptr norm2(p)
  Reg ptr p;
 {
  Reg ptr s,t;
   psh(s=genmul(CAR(p),CAR(p)));
   psh(t=genmul(CDR(p),CDR(p)));
   s=genadd(s,t);
   sp_pull(2);
   return s;
  }

ptr s_conjugate(int narg,ptr env)
  
 {
  Reg ptr p=*(stack-1);
   checknarg(narg-1);
  if(REALP(p))  return p;
  if(COMPLEXP(p))  
      return complex(CAR(p),minus(CDR(p)));
 return error(E_typemis,p);
 }

ptr s_phase(int narg,ptr env)
  
 {
  Reg ptr p=*(stack-1);
   checknarg(narg-1);
    if(zerop(p)) return p;
   if(REALP(p))
    {
      if(gsign(p))  return ATOMVAL(a_pi);
      return MAKEDBL(0.0);
    }
   if(COMPLEXP(p))
    {
      return ATAN(CDR(p),CAR(p));
    }
    return error(E_notnum,p);
  }                 

ptr s_makepolar(int narg,ptr env)

 {
  Reg ptr r=*(stack-2),arg=*(stack-1);
  
   checknarg(narg-2);
   psh(arg=genmul(arg,ATOMVAL(a_imag)));
   arg=*(stack-1)=EXP(arg);
   r=genmul(r,arg);
  pull();
  return r;
}
         
ptr s_signum(int narg,ptr env)
  
 {
  Reg ptr p=*(stack-1),q;
   checknarg(narg-1);
    if(zerop(p)) return p;
   if(REALP(p))
    {
      if(gsign(p)) 
           q=MINUSONE;
       else
           q=ONE;
       if(SINTP(p)||RATIOP(p)) return q;    
      return _float(q);
    }
   if(COMPLEXP(p))
    {
       return gendiv(p,ABS(p));
    }
    return  error(E_notnum,p);
  }                 
 

