/***  equal.c
***/
#define EQUAL_C

#include "lisp.h"
#include <stdio.h>

extern ptr *get_vector();

static ptr vector_equal();

ptr s_equal(int narg,ptr env)
      /* (equal x y) */
    
 {
    ptr equal();
    return equal(*(stack-2),*(stack-1));
 }
ptr s_eqv(int narg,ptr env)
      /* (eqv x y) */
    
 {
    ptr eqv();  /*** 90.5.22 ***/
    return eqv(*(stack-2),*(stack-1));
 }
/***
ptr s_equalp(int narg,ptr env)
    
 {
    ptr equalp();
    return equalp(*(stack-2),*(stack-1));
 }
***/
ptr eqv(p,q)
      /* sub for (eql x y) */
    Reg ptr p,q;
 {
    extern ptr n_eq();
    Reg int n;
    if(p==q) return a_t;
    if(SREGP(p)||SYMBOLP(p)||SREGP(q)||SYMBOLP(q)) return a_f; 
    n=ATTR(p);
    if(n!=ATTR(q)) return a_f; /*** see RSR5 **/
    if(NUMBERP(p)){
      return PRED(gen_eq(p,q));
     }
   return a_f;
 }
ptr equal(p,q)
      /* sub for (equal x y) */
    Reg ptr p,q;
 {
    
    Reg int n;
    extern ptr n_eq();
    if(p==q) return a_t;
    if(SREGP(p)||SYMBOLP(p)||SREGP(q)||SYMBOLP(q)) return a_f; 
    n=ATTR(p);
     if(n!=ATTR(q)) return a_f;
    if(B_NUMBERP(n))
          return eqv(p,q);
    if(B_STRINGP(n))
      {
         return string_equal(p,q);
      }
    if(B_VECTORP(n))
      {
         return vector_equal(p,q);
      }
    
    if(n) return a_f;/** see CL p.61**/
    if(equal(CAR(p),CAR(q))==a_f) return a_f;
   return equal(CDR(p),CDR(q));
 }

static ptr vector_equal(ptr p,ptr q){
  Reg ptr *v,*w;
  int n,m;
  v=get_vector(p,&n);
  w=get_vector(q,&m);
  if(n!=m) return a_f;
  while(n--){
    if(equal(*v++,*w++)==a_f) return a_f;
  }
  return a_t;
}


/*** 
array_equalp(p,q)
  Reg ptr p,q;
{
  Reg unsigned int rank,n,*s,*u;
  Reg ptr x,a_f=a_nil;
  
    rank=ARANK(p);
    if(rank!=ARANK(q)) return a_f;
    s=CAR(p);
    u=CAR(q);
    n=*s++;
    if(n!=*u++) return a_f;
    if(rank==1)
     {   ** only fill-ptr match!!**
       s++;
       u++;
     }
    else
      while(rank--)
       {
         if(*s++!=*u++) return a_f;
       }
    rank=ARANK(p);
     while(n--)
      {
        x=simple_aref(p,n,rank);
        if(equalp(x,simple_aref(q,n,rank))==a_f) return a_f;
       }
     return a_t;
   }
   
  ptr tree_equal(x,y,test_f,reverse)
    Reg ptr x,y,test_f;
    int reverse;
   {
     Reg ptr s,para,a_f=a_nil;
     
     if(ATOM(x))
      {
        if(!ATOM(y)) return a_f;
        if(test_f)
         {
          psh(para=CONS(x,CONS(y,a_f)));
          s=apply(test_f,para,a_f);
          pull();
         }
        else
         s=eql(x,y);
       if(reverse) return PRED(s==a_f);
       return s;
       }
      if(tree_equal(CAR(x),CAR(y),test_f,reverse)==a_f) return a_f;
      return tree_equal(CDR(x),CDR(y),test_f,reverse);
    }
****/

