/***  format.c 
***/
/*  89.6.15 format.c start */
/**  91.8.13  format_stream  is introduced ***/
/***  SS lisp version start 2003.9.22   ***/
/**  2014.9.1  almost complete  version ***/
#include "lisp.h"
#include <stdio.h>
#include <ctype.h>


#define  KANJIP(x)   (kanji_mode&&((x)&0xff)>127)   /* 89.8.30*/

#define PAGE 12

/* int para[10];   used in llprin.c 89.7.7 ****/
#define e_atto  (modeb==2)
#define e_katto  (modeb==3)

extern ptr fmopen(),fmclose(),check_CAR(ptr);
extern ptr sys_close_str(ptr);
extern ptr char_space;
extern void form_err(int,ptr);
extern int para_num(ptr ,int ,int );

ptr para_pchar(ptr  para,int ind,ptr def);

extern ptr capital();   /*** in s_str_cap.c  ***/
    /***   (ctrl,start)    return is len   ****/
/*** static ptr argv;  89.7.8 defined ,use for V-parame-ta- ***/
/** extern int col_loc[];  *** 89.7.26 see file.c ***/
extern int get_pos(ptr stream);   /**  stream.c  **/
extern ptr  format_out_simple(ptr stream,ptr c,ptr para,ptr mode,ptr  args,ptr orgargs);
/*** #define pos(stream)  POS_OUT(stream)  col_loc[stream]*/

static char buff[50]; // only for fdebug

void fdebug(ptr s,int n){
  sprintf(buff,"format debug(%d)\n",n);
  pr_cstr(STDERR,buff);
  fprintf(stderr,"s=");
  princ(s,STDERR);
  princ(MAKECHAR('\n'),STDERR);
}


/***  2014.9.1 New version start here  ***/
// para => list access
ptr para_ref(ptr  para,int  n){
  while((n>0)&&(para!=a_nil)){
    para=CDR(para);
    n--;
  }
 if(( n== 0)&& (para!=a_nil))
     return CAR(para);
  return a_f;
 }

void ignore_wspace(ptr in){
    ptr c;
    int code,cont=1;
    c=read_char(in);
    while (cont &&(c!=SEOF)){
       code=CHAR_CODE(c);
        if(isspace(code)&&(code !='\n'))
              c=read_char(in);
            else{
                unreadchar(c,in);
                cont=0;
            }
  }
}

ptr read_f_string(ptr in, ptr c){
    ptr out;
    out=open_str(a_nullstr,write_ac);
  psh(out);
     while (c!=SEOF){
        princ(c, out);
        //princ(c,STDERR);  //debug
        c=read_char( in);
        if(CHAR_CODE(c)=='~'){
             unreadchar( c ,in);
             break;
        }
     }
    c=sys_close(out);
    pull();
 //fdebug(c,3);
  return c;
}


ptr read_f_directive(ptr  ctrl_path){
 /* (let* ( (p #f)(para ()) (mode 0)(sign #f)(k 0)
          (c (read-char ctrl-path))(notread #f)(cont #t))
*/
 int mode=0,sign=0,k=0,code,cont=1,notread=0;
 ptr c,p=a_f,para=a_nil,prev=a_nil;
    psh(para);  //Caution!!!
    c=read_char(ctrl_path);
   while (cont&& (c!=SEOF)){
       code=CHAR_CODE(c);
       switch(code){
          case ',':
                if(para==a_nil){
                   para=SCONS(p, para);
                   *(stack-1)=para;
                   prev=para;
                }
                else{
                   p=SCONS(p,a_nil);
                   CDR(prev)=p;
                   prev=p;
                }
                 p=a_f;
                 break;
          case '+': break;
          case '-': sign=1;
                    break;
          case '\'':
                  p=read_char(ctrl_path);
                  break;
           case '#':
                  p=CONS(c,a_nil);
                  break;
           case 'V':c=MAKECHAR('v');
           case 'v':
                  p=CONS(c,a_nil);
                   break;
           case ':':
                  mode|=1;
                   break;
           case '@':
                  mode|=2;
                   break;
           case '!':
                  mode|=4;   // ss-extension
                   break;
           default:
                if(isdigit(code)){
                  while(isdigit(code)){
                    k=k*10+code-'0';
                    c=read_char(ctrl_path);
                    code=CHAR_CODE(c);
                 }
                if( sign){
                     k= - k;
                     sign=0;
                }
                p=MAKESINT(k);
                k=0;
                notread=1;
                }
           else{
                cont=0;
                notread=1;
              }
              break;
        }
        if( notread)
            notread=0;
        else
                    c=read_char(ctrl_path);
   }
   if(p!=a_f){
          p=SCONS(p, a_nil);
          if(prev!=a_nil) CDR(prev)=p;
          else{
             para=p;
             *(stack-1)=p;
         }
   }
   if((code=='\n')&&(mode!=1)) ignore_wspace(ctrl_path);
    //(list (char-downcase c) mode (reverse para))   ;;; last char and string parameter includes c
     p=SCONS(MAKESINT(mode),SCONS(para,a_nil));
     p=SCONS(MAKECHAR(tolower(code)),p);
    pull();
   //fdebug(p,0);
   return p;
}
static char nest_char[4]={'[','<','(','{'};
static char nest_char_target[4]={']','>',')','}'};

int block_char_p(int c){
 int i=0;
 while(i<4){
    if(c==nest_char[i]) return nest_char_target[i];
    i++;
 }
return 0;
}

ptr read_f (ptr in);

ptr read_f_block(ptr c,ptr cmd,ptr  target,ptr in){
  ptr res=a_nil,prev=a_nil,x;
  int cont=1;
   psh(res);
    while(1){
           x= read_f( in);
           if(x==SEOF) form_err(E_fm_block,res);
           if(CONSP(x)){   // directive
           if (CAR(x)== target)
                 break;
           }
           if(prev==a_nil){
                res=SCONS(x,a_nil);
                prev=res;
                *(stack-1)=res;  //!!!
           }
           else{
              x=SCONS(x,a_nil);
              CDR(prev)=x;
              prev=x;
           }
   }
     c=SCONS(res,a_nil);
     c=SCONS(x,c);
     c=SCONS(cmd,c);
         /** (list cmd x (reverse res))  ;;;  block  ***/
     pull();
     return c;
} 

ptr read_f (ptr in){
  ptr c,res=a_nil,cmd;
  int target;
  c=read_char(in);
    if(CHAR_CODE(c)=='~'){
                 cmd=read_f_directive( in);
                 c=CAR( cmd);
                 target=block_char_p( CHAR_CODE(c));
                 if( target){
                      psh(cmd);
                      cmd=read_f_block( c, cmd, MAKECHAR(target), in);
                      pull();
                 }
                return cmd;
        }
      else if(c==SEOF) return c;
      else
         return read_f_string( in, c) ;
}

           
ptr my_sformat();

ptr myformat(ptr  stream,ptr ctrl, ptr args){
  ptr Info;
   Info=makevector(2,a_f);
   psh(Info);
     if (stream==a_t)
          stream=STDOUT;
     if (stream==a_f){
          stream=open_str(a_nullstr,write_ac);
         psh(stream);
           my_sformat(stream, ctrl, args, args, Info);
           //ctrl=sys_close(stream);
           ctrl=sys_close_str(stream);   // not copy
         sp_pull(2);
         return ctrl;
      }
     else{
       args=my_sformat( stream, ctrl, args, args, Info);
       pull();
       return args;
     }
}

ptr s_myformat(int narg, ptr env)
{
  /***   lsubr ****/
  Reg ptr stream;
  Reg ptr ctrl,p,*sfree,args=a_nil,last=a_nil;
  if(narg<2) checknarg(narg-2);
  sfree=stack-narg;
  stream=*sfree++;
  ctrl=*sfree++;
  narg-=2;
  if(narg>0){
     args=CONS(*sfree++,a_nil);
     last=args;
     narg--;
  }
  if(args!=a_nil) psh(args); // for gbc
  while(narg>0){
     p=CONS(*sfree++,a_nil);
     CDR(last)=p;
     last=p;
     narg--;
  }
  p=myformat(stream,ctrl,args);
  if(args!=a_nil) pull();
  return p;
}


ptr make_ctrl(ptr ctrl_str ){
  ptr ctrl_path,c,res=a_nil,prev=a_nil;
    ctrl_path=open_str(ctrl_str,read_ac);
   //fdebug(ctrl_str,1);
    psh(ctrl_path);
    psh(res);

    c=read_f(ctrl_path);
    while (c!=SEOF){
            c=SCONS(c,a_nil);
       if(prev==a_nil){
             res=c;
            prev=c;
           *(stack-1)=c;  // 
       }
      else{
         CDR(prev)=c;
         prev=c;
      }
    c=read_f(ctrl_path);
   }
   sys_close(ctrl_path);     
   sp_pull(2);
   //fdebug(res,2);
   return res;
}

ptr  sformat_exec(ptr stream,ptr  ctrl,ptr  args,ptr org,ptr Info);

ptr my_sformat(ptr stream ,ptr ctrl_str,ptr args,ptr org,ptr Info){
             // ;;; org needs for ~:*  back up args see P.598
   ctrl_str=make_ctrl(ctrl_str);
   psh(ctrl_str);
  args=sformat_exec( stream ,ctrl_str,args,org,Info);
  //   ;;; args  returns
   pull();
  return args;
}

ptr sformat_exec_directive(ptr c,ptr stream,ptr directive,ptr args,ptr orgargs,ptr Info);   
ptr sformat_exec_block(ptr stream,ptr block,ptr args,ptr orgargs,ptr Info);

ptr  sformat_exec(ptr stream,ptr  ctrl,ptr  args,ptr org,ptr Info){
     ptr directive,c;
   while(CONSP(ctrl)){
      directive= CAR(ctrl);
      ctrl=CDR(ctrl);
     if(STRINGP(directive))
             princ(directive,stream);
     else{
           c=  CAR(directive);
            if(CHARP( c))
              args=sformat_exec_directive( c ,stream,directive,args,org,Info); //args  returns
            else
              args=sformat_exec_block(stream,directive, args, org, Info);   //args  returns
            
          if(vector_ref(Info,0)!=a_f) ctrl=a_nil;   //;;~^ termination
     }
   }
  return args;
}

static char simple_char[]={'s','a','%','&','~','r','d','b','o','x','*','p','c','|','t','\n','e','f','g','$','\0'};

int format_simplep(ptr c){
  int code,i=0,s;
   code=CHAR_CODE(c);
   while((s=simple_char[i])!='\0'){
      if(code==s) return 1;
      i++;
   }
   return 0;
}

ptr fpara_exec( ptr para_list, ptr args){
    ptr x;
   while(CONSP(para_list)){
      x=CAR(para_list);
      if(CONSP(x)){    //   (#),(V)
            x=CAR(x);
           if( CHAR_CODE(x)=='#')
               CAR(para_list)=MAKESINT(nc_length(args));  //hakai-teki
           else{
               CAR(para_list)=CAR(args);  //hakai-teki
               args=CDR(args);
               } 
       }
      para_list=CDR (para_list);
   }
 return  args;
}

ptr format_out_complex(ptr stream,ptr c,ptr para,ptr mode,ptr args,ptr orgargs,ptr Info);

ptr sformat_exec_directive(ptr c,ptr stream,ptr directive,ptr args,ptr orgargs,ptr Info){   
  ptr para,mode;
  para=CAR(CDR(CDR(directive)));
  mode=CAR(CDR(directive));
     args=fpara_exec(  para, args);
     if(format_simplep( c))
        return format_out_simple( stream ,c ,para, mode ,args, orgargs);
     else
        return format_out_complex(stream, c, para, mode, args, orgargs, Info); //not block
 }

ptr format_Out(ptr stream,ptr  para,ptr mode,ptr args,ptr  Info);
ptr formIndirection(ptr  args,ptr stream,ptr para,ptr mode,ptr org,ptr Info);

ptr format_out_complex(ptr stream,ptr c,ptr para,ptr mode,ptr args,ptr orgargs,ptr Info){
   int code;
     code=CHAR_CODE(c);
    switch(code){
          case '^':   //Up and Out
            return format_Out(  stream,  para, mode, args,  Info);
               
            case '?':   //  Indirection
             return formIndirection(args, stream,  para, mode, orgargs, Info );
           default:
            form_err( E_fm_directive, c);
         }
   return mode; //Never
}

ptr format_Out(ptr stream,ptr  para,ptr mode,ptr args,ptr  Info){
   ptr x,out=a_f,w,w1,w2;
             w=para_ref( para, 0);
      if (SINTP(w)){
              if(w== ZERO) out=a_t;
               w1= para_ref( para, 1);
               if(SINTP( w1)){
                   if(w == w1) out=a_t;
                    w2 =para_ref(para, 2);
                   if (SINTP(w2)){
                      if((w<=w1)&&(w1<=w2))
                        out=a_t;
                   }
               }
            }
      else{
          if(mode==ONE){
               if(vector_ref( Info, 1)==a_nil) out=a_t;   // ~:^
           }
          else{
              if (args==a_nil) out=a_t;
           }
      }
      if(out==a_t)
          vector_set( Info, 0, mode);
   return args;
}
/**    Indirection P.598  **/
ptr formIndirection(ptr  args,ptr stream,ptr para,ptr mode,ptr org,ptr Info){
   ptr ctrl,indargs;
      if(args==a_nil) form_err( E_fm_arg, args);
       ctrl=CAR(args);
       args=CDR(args);
      switch((long)mode){
           case (long)ZERO:     // 
             if(args==a_nil) form_err( E_fm_arg, args);
                indargs=CAR(args);
                args=CDR(args);
              my_sformat( stream, ctrl, indargs, indargs, Info);
              vector_set(Info, 0,a_f);   // ignore termination in arg-ctrl
                 break;
           case (long)TWO:   // mode 2    @?
               args=my_sformat( stream, ctrl, args, org, Info);
              vector_set(Info, 0,a_f);  // ignore termination in arg-ctrl P.607!!!
               break;
          default: form_err( E_fm_mode, mode);
      }
   return args;
}

ptr format_Case(ptr stream,ptr para,ptr mode,ptr args,ptr ctrl,ptr orgargs,ptr Info);
ptr format_Cond(ptr stream,ptr  para,ptr mode,ptr args,ptr ctrl,ptr orgargs,ptr Info);
ptr format_Ite(ptr stream,ptr para,ptr mode,ptr args,ptr ctrl,ptr orgargs,ptr Info,ptr end);
ptr format_Just(ptr stream,ptr para,ptr mode,ptr args,ptr ctrl,ptr org,ptr Info);
void format_Just_aux(ptr  stream,ptr  para,ptr mode,int w,int  total,ptr res,int len);

ptr sformat_exec_block(ptr stream,ptr block,ptr args,ptr orgargs,ptr Info){//args  returns
   ptr s,end,ctrl,c,para,mode; 
   int code;
     s=CAR(block);
     end=CAR(CDR ( block));
     ctrl=CAR(CDR(CDR (block)));
     c= CAR( s);
     para=CAR(CDR(CDR (s)));
     mode=CAR(CDR(s));
     args= fpara_exec(  para, args);
     code=CHAR_CODE(c);
      switch(code){
        case  '(':      //Case conversion  )
            return format_Case(stream,  para, mode, args, ctrl, orgargs, Info);
          case '[':      //Conditional ]
            return format_Cond(stream , para, mode, args, ctrl, orgargs, Info);
          case '{':     //Iteration
                        //  need end for ~:}
            return format_Ite(stream, para, mode, args, ctrl, orgargs, Info, end);  
          case '<':      //Justification >
            return format_Just(stream,  para, mode, args, ctrl, orgargs, Info);
          default:
            form_err( E_fm_directive, c);
     }
   return args; //Never
}
/**  Case conversion   ~( str ~)  **/
ptr format_Case(ptr stream,ptr para,ptr mode,ptr args,ptr ctrl,ptr orgargs,ptr Info){
   ptr x,out;
   int modeb;
      modeb=GETNUM(mode);
      out=open_str(a_nullstr,write_ac);
      psh(out);
          args=sformat_exec(out, ctrl, args, orgargs, Info);
           vector_set( Info, 0,a_f);
       x=sys_close(out);
       *(stack-1)=x;
          princ(capital(x,modeb,0,-1),stream);  //s_str_cap.c
       pull();
      return args;
}

ptr take_clauses_flag (ptr ctrl){
      ptr res=a_nil,prev=a_nil,clause=a_nil,prev_clause=a_nil,x,flag=a_nil,prev_flag=a_nil,semi;
      int n=0;
      psh(res);
      psh(clause);
      psh(flag);
      semi=MAKECHAR(';');
     while (CONSP( ctrl)){
         x=CAR(ctrl);
         ctrl=CDR(ctrl);
        if((CONSP( x))&&(CAR(x )==semi)){  //  ~;
             if(CAR(CDR(x))==ONE){    //   ~:;
                 /*** (push  (cons n (cddr x))  flag)  ;;; with para, (n para), for Just
                  ***/
                 x=SCONS(MAKESINT(n),CDR(CDR(x)));
                 x=SCONS(x,a_nil);
                 if(flag==a_nil){
                   flag=x;
                   prev_flag=x;
                   *(stack-1)=x;
                  }
                 else{
                   CDR(prev_flag)=x;
                   prev_flag=x;
                 }
             }
            //  (push (reverse clause) res)
                 x=CONS(clause,a_nil);
            if(res==a_nil){
                 res=x;
                 prev=res;
                *(stack-3)=res;
            }
            else{
               CDR(prev)=x;
               prev=x;
            }
            clause=a_nil; 
            n++;
          }
        else{
          x=SCONS(x,a_nil);
          if(clause==a_nil){
               clause=x;
               prev_clause=x;
               *(stack-2)=x;
           }
          else{
               // (push x clause)
               CDR(prev_clause)=x;
               prev_clause=x;
            }
        }
     }
  //  (push (reverse clause) res)
         x=CONS(clause,a_nil);
     if(res==a_nil){
                 res=x;
                *(stack-3)=x;
            }
            else{
               CDR(prev)=x;
            }

  //(cons (reverse res) (reverse flag))
   x=CONS(res,flag);
  sp_pull(3);
  return x;
}


int check_else(int  len,ptr  flags){
   return ((nc_length(flags)== 1)&&  (GETNUM((CAR(CAR(flags))))== (len- 2)));
}
/***  see list.c   nthcdr ***/
ptr list_ref(q,n)
    Reg ptr q;
    Reg int n;
 {
   Reg int k=n;
   while(n--)
    {
    /*** if(ENDP(q)) form_err(E_range,MAKESINT(k)); ***/
    if(SSATOM(q)||q==a_nil) form_err(E_range,MAKESINT(k));  /*** 2012.2.5  ***/
    q=CDR(q);
    }
   return CAR(q);
 }

/** Conditional ~[s0~;s1~;...~;sn~]  **/
ptr format_Cond(ptr stream,ptr  para,ptr mode,ptr args,ptr ctrl,ptr orgargs,ptr Info){
   ptr x,clauses,w,sel_clause=a_f;
    int else_flag,modeb;
   int len,sel;
          w=para_ref( para, 0);
             x=take_clauses_flag( ctrl);
          psh(x);  //!!!
             clauses= CAR(x);
             len= nc_length( clauses);
              modeb=GETNUM(mode);
             else_flag=check_else( len, CDR( x));
           switch(modeb){
              case 0: 
                        if (SINTP(w))
                            sel= GETNUM(w);
                        else{
                            x=check_CAR(args);
                            if(SINTP(x))
                                 sel= GETNUM(x);
                            else
                               form_err(E_fm_type,x);
                            args=CDR(args);
                        }
                        if (else_flag &&(sel>= len))
                             sel= len- 1;
                        if (sel<len)
                           sel_clause=list_ref(clauses, sel);
                       break;
              case 1:    /**  ~:[ false~;true~]  **/
                        if (len== 2){
                            x=check_CAR(args);
                            args=CDR(args);
                           if (x!=a_f)
                                sel_clause=CAR(CDR (clauses));
                           else
                                sel_clause=CAR(clauses);
                          }
                        else
                          form_err( E_fm_cond,MAKESINT(len));
                       break;
              case 2:     /**  ~@[ true~] **/
                        if ( len== 1){
                            x=check_CAR(args);
                           if (x!=a_f)
                                sel_clause=CAR(clauses);
                           else
                                args=CDR(args);
                          }
                         else
                           form_err( E_fm_cond, MAKESINT(len));
                       break;
              default:
                          /**   ~:@  **/
                           form_err( E_fm_mode, mode);
                 }
     if( sel_clause!=a_f)
        args=sformat_exec( stream, sel_clause, args, orgargs, Info);  // args  returns
    pull();
     return  args;
  }

/** Iteration ~{str ~}  **/

ptr sub_Ite_Bound(ptr stream,ptr ctrl,ptr args,ptr mode,ptr Bound,int colon_f,ptr orgargs,ptr Info){
 ptr step;
 int abort=0,modeb,bound=-1;
 modeb=GETNUM(mode);
 if(SINTP(Bound)) bound=GETNUM(Bound);
  while ((CONSP(args)||colon_f)&&(bound!= 0)){
      colon_f=0;
      if(bound>0) bound--;
      switch(modeb){
         case 0:  /**   0,2  **/
          args=sformat_exec(stream, ctrl, args, orgargs, Info);   // args  returns
          abort= (vector_ref( Info, 0)!=a_f);
          if( abort) bound= 0;
          break;
         case 1:  /**  1,3  **/
               step=CAR (args);
               args=CDR(args);
               vector_set(Info, 1, args);
               sformat_exec( stream, ctrl,  step, step , Info); 
          abort= (vector_ref( Info, 0)!=a_f);
          if( abort) bound= 0;
               //  ~:^
           break;
     }
    if( abort) vector_set(Info, 0 ,a_f);
  }
  //(vector-set! Info 1 #f)  ;;; maybe not need
  return args;
}

ptr format_Ite(ptr stream,ptr para,ptr mode,ptr args,ptr ctrl,ptr orgargs,ptr Info,ptr end){
   ptr x;
   ptr NewInfo,Bound;
   int colon;
    //  for recursive call
        NewInfo=makevector(2,a_f);
        Bound=para_ref( para, 0);

          /**  #t if ~{   ~:}  **/
         colon = (CAR(CDR(end))==ONE );
         psh(NewInfo);  //Caution!!!
         psh(ctrl);  //Caution!!!
          if(ctrl==a_nil){      // see P603
             ctrl= CAR (args);
             args=CDR(args);
             if(!STRINGP(ctrl)) form_err( E_fm_control, ctrl);
             ctrl=make_ctrl(ctrl);
            *(stack-1)=ctrl;
          }
          if((mode==ZERO)||( mode==ONE )){
                          x=CAR(args);  // Iteration args
                          args=CDR(args);
                          sub_Ite_Bound(stream, ctrl, x , mode,  Bound, colon, orgargs, NewInfo);
                   }
             else {     //   ~:@
                      mode= (ptr)((long)mode& (long)ONE);
                      args=sub_Ite_Bound( stream, ctrl, args,  mode,  Bound, colon, orgargs, NewInfo);
                 }
      sp_pull(2);
      return args;
}

/***   Justification  ~w,colinc,minpad,padchar<s0~;s1~;...~;sn~>
        P.604
***/

ptr check_top(ptr flags){
   if((nc_length (flags)>= 1) && (CAR(CAR(flags))==ZERO))
          return CAR(CDR(CAR(flags)));
   else 
          return a_f;
}

ptr format_Just(ptr stream,ptr para,ptr mode,ptr args,ptr ctrl,ptr org,ptr Info){
   ptr x,outstream,res=a_nil,prev=a_nil,clauses,top=a_f;
   int w;
  ptr  else_flag;
   int n,len=0,total=0;
  int line_width= 72, line_pos=0,add_sp= 0;    // see P.605
             w=para_num( para, 0,0);
             x= take_clauses_flag( ctrl);
     psh(x);  //Caution!!
     psh(res);  //Caution!!
              clauses=CAR (x);
             else_flag=check_top(  CDR( x));
        while (clauses!=a_nil){
            outstream=fmopen();
           args=sformat_exec( outstream ,CAR( clauses), args, org, Info);   //args  returns
            x=fmclose();
             if(vector_ref( Info, 0)!=a_f){
                     //  ~^ aborts this clause P.605
                   vector_set( Info, 0 ,a_f);
                   clauses=a_nil; 
                }
               else{
                  get_string(x,(Uint *)&n);   // n=string-length x
                    //  (push x res)
                 x=SCONS(x,a_nil);
                 if(res==a_nil){
                    res=x;
                     *(stack-1)=x;
                     prev=x;
                 }
                 else{
                     CDR(prev)=x;
                     prev=x;
                 }
                 total+= n;
                 len++;
                 clauses=CDR(clauses);
               }
           }
           // while end
            if(else_flag!=a_f){
                   top=CAR( res);
                   res=CDR(res);
                   len--;
                  get_string(top,(Uint *)&n);   // n=string-length  top
                   total-=n;
                   if(CONSP(else_flag)){
                        x=CAR(else_flag);
                        if(SINTP(x))  add_sp=GETNUM(x);   //  else 0
                        if(CDR(else_flag)!=a_nil){
                          x=CAR(CDR(else_flag));
                          if(SINTP(x)) line_width=GETNUM(x);   // else  72
                        }
                   }
                line_pos=get_pos( stream);   // stream.c 
            }
            if (total>= w){
                 if(top!=a_f){
                     if( (line_pos+total+add_sp)> line_width)
                       princ( top, stream);
                  }
                 while (res!=a_nil){
                    princ(CAR( res), stream);
                    res=CDR(res);
                 }
                }
            else{
                 if( top!=a_f){
                     if (( line_pos+ w +add_sp)> line_width)
                       princ( top, stream);
                 }
                format_Just_aux(  stream,  para, mode, w ,total, res, len);
              }
      sp_pull(2);
    return   args;
}

void pad(ptr pad_c,int n ,ptr stream){
   while(n> 0){
      princ( pad_c, stream);
      n--;
   }
}

int pad_rest(int  sp,int  rest,ptr  pad_c,ptr stream){
    if(rest> 0){
         sp++;
        rest--;
    }
  pad( pad_c, sp, stream);
  return rest;
}
/******
  mode 0  A  { s+minpad+rest B}    times of s =len-1
  mode 1  s rest A { s+minpad+rest  B}    times of s =len
  mode 2  A  { s+minpad+rest  B}  s    times of s =len
  mode 3  s rest A { s+minpad+rest  B}  s    times of s =len+1
*******/
 void  display_res(ptr res,int smin,int rest,ptr pad_c,ptr stream){
            while (res!=a_nil){
                rest= pad_rest( smin, rest, pad_c, stream);
                princ(CAR(res), stream);
                res=CDR(res);
            }
  }

void format_Just_aux(ptr  stream,ptr  para,ptr mode,int w,int  total,ptr res,int len){
   int x, k, spaces,colinc,minpad;
//,pad_char;
   int n ,s, rest,div,smin,modeb; 
   ptr pad_c;
        spaces=w- total;
        colinc= para_num( para, 1, 1); 
        minpad= para_num( para, 2 ,0);
         //pad_char= para_char( para, 3,' ');   //  pad-char
         pad_c= para_pchar( para, 3,char_space);   //  pad-char
         //pad_c=MAKECHAR(pad_char);
         modeb=GETNUM(mode);
        x= minpad* (len- 1);
          if (x> spaces){
                n= total+ x;
                while (w < n)
                     w+= colinc;
              spaces= w- total;
         }
        n= spaces- x;    //spaces except for minpad
           if(modeb== 0) div=len- 1;
           else if(modeb==3) div=len+ 1;
           else 
               div=len;
         if(div> 0){
             s= n/ div;   //  each space
            rest= n- s* div;
           }
         else{     //  modeb=0,len=1
             s= n;   //   each space
             rest= 0;
          }
        smin= s+ minpad;
          switch(modeb){
                case 0:
                        if (len== 1){
                            pad( pad_c, spaces, stream);
                            princ( CAR(res), stream);
                          }
                        else{
                            princ(CAR(res), stream);
                            res=CDR(res);
                           display_res(res,smin,rest,pad_c,stream);
                         }
                       break;
               case  1:       //   ~:  first is right-justified
                         rest= pad_rest( s ,rest, pad_c, stream);
                         princ(CAR(res), stream);
                         res=CDR(res);
                           display_res(res,smin,rest,pad_c,stream);
                       break;
               case 2:      //  last is left-justified
                          princ(CAR(res), stream);
                          res=CDR(res);
                           display_res(res,smin,rest,pad_c,stream);
                         pad (pad_c,  s, stream);
                       break;
               case 3:     // first is right-, and last is left-justified
                          rest =pad_rest( s ,rest, pad_c, stream);
                          princ(CAR(res), stream);
                          res=CDR(res);
                           display_res(res,smin,rest,pad_c,stream);
                         pad( pad_c,  s, stream);
                      break;
               default:
                        form_err( E_fm_mode, mode);
                    
            }
}






