/****  genmath.c   ***/

#include "lisp.h"
extern void checknarg();
extern void init_sub();


/***   INT, BIG  +- * /  */
/*  89.2.10  */
/** 91.2.19 complex ***/
/** 2018.3.14  genmul,genadd,gensub,gendiv  psh p,q for gbc ***/

#define SINT  0
#define BINT    1
#define RATIOF 2
#define FLOAT 3
#define COMPLEXF  4

extern ptr  add(),sub(),mul(),intdiv();
extern ptr  longadd(),longsub(),longmul(),longdiv();
extern ptr  ratioadd(),ratiosub(),ratiomul(),ratiodiv();
extern ptr  floatadd(),floatsub(),floatmul(),floatdiv();
extern ptr  complexadd(),complexsub(),complexmul(),complexdiv();
extern double get_float();
ptr intadd(),intsub(),intmul(),intdiv();

static ptr (* add_f[5])()={add,intadd,ratioadd,floatadd,complexadd};
static ptr (* sub_f[5])()={sub,intsub,ratiosub,floatsub,complexsub};
static ptr (* mul_f[5])()={mul,intmul,ratiomul,floatmul,complexmul};
static ptr (* div_f[5])()={intdiv,intdiv,ratiodiv,floatdiv,complexdiv};
/****
static int sub_f[5]={sub,intsub,ratiosub,floatsub,complexsub};
static int mul_f[5]={mul,intmul,ratiomul,floatmul,complexmul};
static int div_f[5]={intdiv,intdiv,ratiodiv,floatdiv,complexdiv};
***/

/***  expand lsubr function to expr2 ***/
ptr expand2(narg,fun)     
    Reg int narg;
    Reg ptr (* fun)();
 {
    Reg ptr q,*sfree=stack-narg,r;
    
    q=*sfree++;
    narg--;
    if(!NUMBERP(q)) error(E_notnum,q);
    psh(q);
    while(narg--)
      {
       r=*sfree++;
    if(!NUMBERP(r)) error(E_notnum,r);
       *(stack-1)=q=(* fun)(q,r);
      }
    return *pull();
 }

ptr gen_math2_SINT(p,q,func)
  Reg ptr  p,q;
  Reg ptr (* func[])();
{
  Reg int b;
  if(SINTP(q))
       return (* func[SINT])(p,q);
   b=ATTR(q);
  if(B_COMPLEXP(b))
           return (* func[COMPLEXF])(_complex(p),q);
   if(B_INTEGERP(b))
      return (* func[BINT])(p,q);
   if(B_RATIOP(b))
        {
           p=ratio(p);
           psh(p);
           p=(* func[RATIOF])(p,q);
           pull();
           return p;
        }
    if(B_DOUBLEP(b))
           return (* func[FLOAT])(_float(p),q); 
    return error(E_notnum,q);
}

ptr gen_math2_SINT_q(p,q,func) /*** q is SINT, p is not ***/
  Reg ptr  p,q;
  Reg ptr (* func[])();
{
  Reg int b;
   b=ATTR(p);
  if(B_COMPLEXP(b))
           return (* func[COMPLEXF])(p,_complex(q));
   if(B_INTEGERP(b))
      return (* func[BINT])(p,q);
   if(B_RATIOP(b))
        {
           q=ratio(q);
           psh(q);
           p=(* func[RATIOF])(p,q);
           pull();
           return p;
        }
    if(B_DOUBLEP(b))
           return (* func[FLOAT])(p,_float(q));
    return error(E_notnum,p);
}

ptr gen_math2(p,q,func)
  Reg ptr  p,q;
  Reg ptr (* func[])();
{
  Reg int a,b;
  if(SINTP(p)){
       p=gen_math2_SINT(p,q,func);
       return p;
  }
  a=ATTR(p);
   if(SINTP(q)){
      p=gen_math2_SINT_q(p,q,func);
       return p;
   }
  b=ATTR(q);
  if(B_COMPLEXP(b))
           return (* func[COMPLEXF])(_complex(p),q);
  if(B_COMPLEXP(a))
           return (* func[COMPLEXF])(p,_complex(q));
   if(B_INTEGERP(a))
    {
      if(B_INTEGERP(b)){
           p=(* func[BINT])(p,q);
           return p;
        }
      if(B_RATIOP(b))
        {
           p=ratio(p);
           psh(p);
           p=(* func[RATIOF])(p,q); 
           pull();
           return p;
        }
      if(B_DOUBLEP(b))
           return (* func[FLOAT])(_float(p),q);
      error(E_notnum,q);
    }
   if(B_DOUBLEP(a))
    {
      return (* func[FLOAT])(p,_float(q));
    }
   if(RATIOP(p))
    {
      if(INTEGERP(q))
         {
           q=ratio(q);
           psh(q);
           p=(* func[RATIOF])(p,q); 
           pull();
           return p;
         }
      if(RATIOP(q)){
           p=(* func[RATIOF])(p,q); 
           return p;
        }
      if(DOUBLEP(q))
         return (* func[FLOAT])(_float(p),q);
      error(E_notnum,q);
    }
    return error(E_notnum,p);
 }
ptr genadd(p,q)
  Reg ptr  p,q;
{
  psh(p);
   psh(q);
   p=gen_math2(p,q,add_f);
   stack-=2;
   return p;
   //return gen_math2(p,q,add_f);
}
ptr intadd(p,q)
  Reg ptr  p,q;
{
   if(SINTP(p))
    {
      if(SINTP(q))
           return add(p,q);
      else
        {
           p=bignum((long)GETNUM(p));
           psh(p);
           p=longadd(p,q); 
           pull();
           return p;
        }
    }
   else
    {
      if(SINTP(q))
         {
           q=bignum((long)GETNUM(q));
           psh(q);
           p=longadd(p,q); 
           pull();
           return p;
         }
      else
           return longadd(p,q);
    }
 }
ptr gensub(p,q)
  Reg ptr  p,q;
{
  psh(p);
   psh(q);
   p=gen_math2(p,q,sub_f);
   stack-=2;
   return p;
  // return gen_math2(p,q,sub_f);
}
ptr intsub(p,q)
  Reg ptr  p,q;
{
   if(SINTP(p))
    {
      if(SINTP(q))
           return sub(p,q);
      else
          {
           p=bignum((long)GETNUM(p));
           psh(p);
           p=longsub(p,q); 
           pull();
           return p;
          }
    }
   else
    {
      if(SINTP(q))
          {
           q=bignum((long)GETNUM(q));
           psh(q);
           p=longsub(p,q); 
           pull();
           return p;
          }
      else
           return longsub(p,q);
    }
 }
ptr genmul(p,q)
  Reg ptr  p,q;
{
   psh(p);
   psh(q);
   p=gen_math2(p,q,mul_f);
   stack-=2;
   return p;
}
ptr intmul(p,q)
  Reg ptr  p,q;
{
   if(SINTP(p))
    {
      if(SINTP(q))
           return mul(p,q);
      else
           return long16mulsub(q,GETNUM(p));
    }
   else
    {
      if(SINTP(q))
           return long16mulsub(p,GETNUM(q));
      else
           return longmul(p,q);
    }
 }

ptr gendiv(p,q)
  Reg ptr  p,q;
{
  psh(p);
   psh(q);
   p=gen_math2(p,q,div_f);
   stack-=2;
   return p;
   //return gen_math2(p,q,div_f);
}



ptr intdiv(p,q)
  Reg ptr  p,q;
{
  /***  rational!!!!! ***/
  if(SINTP(q))
     {
       if(q==ZERO) error(E_divzero,q);
       if(q==ONE)  return p;
       if(SINTP(p)) return intdiv_sint(p,q);
       return intdiv_long(p,ptr2bignum(q));
     }
  return intdiv_long(ptr2bignum(p),q);
  /**  return checkratio(yakubun(p,q)); **/
 }

ptr genremain(p,q)
  Reg ptr  p,q;
{   
  if(zerop(q))   error(E_divzero,q);
  if(zerop(p)) return p;    

   if(SINTP(p))
    { 
      if(SINTP(q))
           return remain(p,q);
      if(BIGINTP(q)){
           return p;
        }
           /*  return    big is always big!!! 89.2.27 */
      if(RATIOP(q))
        {
          p=ratio(p);
          psh(p);
          p=ratioremain(p,q);
          pull();
          return p;
        }
      if(DOUBLEP(q))
           return floatremain(_float(p),q);
      error(E_notnum,q);
    }
   else if(DOUBLEP(p))
    {
      return floatremain(p,_float(q));
    }
   else if(BIGINTP(p))
    {
      if(SINTP(q))
           return long16remain(p,GETNUM(q));
      if(BIGINTP(q))
           return longremain(p,q);
      if(DOUBLEP(q))
         return floatremain(_float(p),q);
      error(E_notnum,q);
    }
   else if(RATIOP(p))
    {
      if(INTEGERP(q))
        {
          q=ratio(q);
          psh(q);
          p=ratioremain(p,q);
          pull();
          return p;
        }
      if(RATIOP(q))
        {
          return ratioremain(p,q);
        }
      if(DOUBLEP(q))
           return floatremain(_float(p),q);
      error(E_notnum,q);
    }
    return  error(E_notnum,p);
 }


ptr genmod(p,q)
  Reg ptr  p,q;
{
  if(zerop(q))   error(E_divzero,q);
  if(zerop(p))   return p;
     
   if(SINTP(p))
    {
      if(SINTP(q))
           return mod(p,q);
      if(BIGINTP(q)){
           if(gsign(q)){
                if( gsign(p)) return p;
            }
           else if(!gsign(p)) return p;
           return genadd(p,q);
        }
           /*  return    big is always big!!! 89.2.27 */
      if(RATIOP(q))
        {
          p=ratio(p);
          psh(p);
          p=ratiomod(p,q);
          pull();
          return p;
        }
      if(DOUBLEP(q))
           return floatmod(_float(p),q);
      error(E_notnum,q);
    }
   else if(DOUBLEP(p))
    {
      return floatmod(p,_float(q));
    }
   else if(BIGINTP(p))
    {
      if(SINTP(q))
           return long16modsub(p,GETNUM(q));
      if(BIGINTP(q))
           return longmod(p,q);
      if(DOUBLEP(q))
         return floatmod(_float(p),q);
      error(E_notnum,q);
    }
   else if(RATIOP(p))
    {
      if(INTEGERP(q))
        {
          q=ratio(q);
          psh(q);
          p=ratiomod(p,q);
          pull();
          return p;
        }
      if(RATIOP(q))
        {
          return ratiomod(p,q);
        }
      if(DOUBLEP(q))
           return floatmod(_float(p),q);
      error(E_notnum,q);
    }
     return error(E_notnum,p);
 }
ptr gen_add(int narg,ptr env)     /*  subr  */
 {
   ptr x;
    if(narg==0) return ZERO;
    if(narg==1) {
      x=*(stack-1);
      if(!NUMBERP(x)) error(E_notnum,x);
      return x;
    }
    return expand2(narg,genadd);
 }

ptr gen_sub(int narg,ptr env)     /*  subr  */
 {
    if(narg==0) return ZERO;
    if(narg==1) return minus(*(stack-1));
    return expand2(narg,gensub);
 }

ptr gen_minus(int narg,ptr env)     /*  subr 1  */
 {
    checknarg(narg-1);
    return minus(*(stack-1));
    //return expand2(narg,genadd);
 }

ptr gen_mul(int narg,ptr env)     /*  subr  */
 {
   ptr x;
    if(narg==0) return ONE;
    if(narg==1) {
      x=*(stack-1);
      if(!NUMBERP(x)) error(E_notnum,x);
      return x;
    }

    return expand2(narg,genmul);
 }

ptr gen_div(int narg,ptr env)     /*  subr  */
 {
    if(narg==0) return ONE;
    if(narg==1) return gendiv(ONE,*(stack-1));
    return expand2(narg,gendiv);
 }

ptr gen_mod(int narg,ptr env)     /*  subr  */
 {
    checknarg(narg-2);
    return genmod(*(stack-2),*(stack-1));
 }

ptr gen_remain(int narg,ptr env)     /*  subr  */
 {
    checknarg(narg-2);
    return genremain(*(stack-2),*(stack-1));
 }


/***  this needs for get floor (p/q) ****/   
/****  p,q are integers & return integer!!! not rational!!! ****/
ptr fixdiv(p,q)
  Reg ptr  p,q;  
{
   if(SINTP(p))
    {
      if(SINTP(q))
           return div_sint(p,q);
      else   /** if(_BIGINTP(q))***/
           return ZERO;  
           /***  return 0..   big is always big!!!  ***/
    }
   else  /** if(_BIGINTP(p)) **/
    {
      if(SINTP(q))
           return long16divsub(p,GETNUM(q));
       else  /**if(_BIGINTP(q))***/
           return longdiv(p,q);
    }
 }

ptr s_quotient(int narg,ptr env){
 Reg ptr p,q;
  checknarg(narg-2);
  p=*(stack-2);
  q=*(stack-1);
  if(INTEGERP(p)){
   if(INTEGERP(q))
     return fixdiv(p,q);
   else error(E_notint,q);
  }
  return error(E_notint,p);
}
 


