/***  lker.c
***/
#define LKER

#include "lisp.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define GBC(x)  strcpy(gbcmsg,x)  //printf("gbc from  lker %s \n",x) 
//#define GBC(x)  

extern void *Mymalloc_CELL(int); //v2.16  
extern unsigned int CELLU_size;  // real size by ptr

int cell_total;

void make_boolean()
{
  /** sym_list=NIL; **/
 a_t=new_cell(BOOLEAN);
  sys_pro(a_t);
  a_f=new_cell(BOOLEAN);
  sys_pro(a_f);
 }

void make_nil()
  {
     Reg ptr c;
    c=a_nil=allcell;
    MARK(c)=NILL;
    CDR(c)=CAR(c)=c;
    /** sys_pro(c); **/
   /*** undef ***/
    a_undef=c=allcell+1;
    MARK(c)=NILL;
    CDR(c)=CAR(c)=c;
    sys_pro(c);
   /*** unbdd  ***/
    a_unbdd=c=allcell+2;
    MARK(c)=NILL;
    CDR(c)=CAR(c)=c;
    sys_pro(c);
  }

void make_free_cell_old()
  {
    Reg int i=4; 
    Reg ptr c;
    fc_begp=free_cell=c=allcell+3;
    while(i++<CELLMAX)
     {
      /** printf("free-cell %x %d\n",c,i); **/
       MARK(c)=FREECELL;
       CAR(c)=a_nil;
       c=CDR(c)=c+1;
     }
    /*** this is last cell ***/
    MARK(c)=FREECELL;
    CDR(c)=a_nil;
    fc_endp=c+1;
    cell_total=c-fc_begp;
 }

void make_free_cell()   /***  New 2007.10.22  **/
  {
    Reg ptr c;
    fc_begp=c=allcell+3;
    fc_endp=allcell+CELLMAX;
    free_cell=a_nil;

    while(c<fc_endp)
     {
      /** printf("free-cell %x %d\n",c,i); **/
       MARK(c)=FREECELL;
       CAR(c)=a_nil;
       CDR(c)=free_cell;
       free_cell=c;
       c++;
     }
    /*** this is last cell ***/
    cell_total=c-fc_begp;
 }
char gbcmsg[32];

ptr new_cell(int attr)
{
  Reg ptr x;
  x=free_cell;
  /** check_cell(x);*  for debug ****/
  if(x==a_nil){
     GBC("new");
     gbc();
      x=free_cell;
     if(x==a_nil) fatal_error( E_cell,x);
    }
  free_cell=CDR(free_cell);
    /**  printf("Lker new_cell %x\n",x);  ***/
   /*** check_cell(free_cell,-1);   for debug ****/
   CDR(x)=a_nil;
   ATTR(x)=attr;
   EXATTR(x)=0;
   /***   printf("Lker new_cell return %x attr %x \n",x,attr); ***/
  return x;
}

  /****  CELL  need for FREECELL  MARK clear ***/
/**
ptr get_cell()
{   
  return new_cell(CELL);
}  
***/
ptr CONS(cx,cy)
  Reg ptr cx,cy;
 {
   Reg ptr x;
    x=free_cell;
  if(x==a_nil){
     GBC("CONS");
     gbc(); 
      x=free_cell;
     // printf("Lker free_cell %x\n",x); 
     if(x==a_nil) fatal_error( E_cell,x);
      //printf("Lker.c free_cell OK\n"); 
    }
  free_cell=CDR(x);
   /*** check_cell(free_cell,-1); *  for debug ****/
   CAR(x)=cx;
   CDR(x)=cy;
   ATTR(x)=CELL;
   EXATTR(x)=0;
    /***  printf("Lker CONS return  %x\n",x); **/
   return x;
 }

/**** safty cons ***/
/**** caution!  SCONS(SCONS(..),SCONS(...)) is not safe ***/
ptr SCONS(cx,cy)
  ptr cx,cy;
 {
   Reg ptr x;
    x=free_cell;
  if(x==a_nil){
     psh(cx);
     psh(cy);
     GBC("SCONS");
     gbc();
      x=free_cell;
     if(x==a_nil) fatal_error( E_cell,x);
     sp_pull(2);
    }
  free_cell=CDR(x);
   /*** check_cell(free_cell,-1);  ** for debug ****/
   CAR(x)=cx;
   CDR(x)=cy;
   ATTR(x)=CELL;
   EXATTR(x)=0;
     /** printf("Lker SCONS return  %x\n",x); ***/
   return x;
 }

/****  for debug   check free_cell by check_cell(free_cell,-1)   ***/
/***
int check_cell(int out)
{
  Reg int n=0,bk=cell_bank;
   n=check_cell_aux(fc_begp,fc_endp,out);
   if((out>0)&&(n>=out)) return n;
   while(bk--){
    n+=check_cell_aux(cell_begin[bk],cell_end[bk],out);
    if((out>0)&&(n>=out)) return n;
   }
   return n;
}
****/
   
int check_cell(ptr x , int out){
   int n=0;
    if(out==-1) out=0x7fffffff; /*** max ***/
  while(1){
    if(x==a_nil) return n;
    if(!OBJP(x)){
       printf("free_cell  %p  abnormal %d\n",x,n);
       exit(999);
     }
    x=CDR(x);
    n++;
    if(n==out) break;
  }
   return n;
}

/****   OBJP
 04.6.14
***/
#define BANKMAX 12

int cell_bank=0;
ptr cell_begin[BANKMAX];
ptr cell_end[BANKMAX];

/***  return YES if LISP-OBJECT and not SREGP  ***/
int OBJP(ptr  x)
{
  Reg int n=cell_bank; 
  if(SREGP(x)) return NO;   /*** SREGP  ***/
  if(x>=allcell&&x<fc_endp) return YES;
   while(n--){
       if(x>=cell_begin[n]&&x<cell_end[n]) return YES;
   }
 return NO;
}

void extends_cell(){
  Reg int n,s; 
  ptr p;
   n=cell_bank; 
  if(n==0) s=10;
  else if(n==1) s=16;
  else if(n==2) s=24;
  else if(n==3) s=32;
  else s=48;
  s*=10000;  /*** add new cell  **/
  if(n>=BANKMAX)fatal_error(E_cell,a_nil);
  //sprintf(iobuff,"cell extends %d\n",s);
  //lwritestr(STDERR,iobuff);
  cell_bank++;
   cell_begin[n]=p=(ptr )Mymalloc_CELL(s*sizeof(struct _cell)); //v2.16  
 /**  cell_begin[n]=p=(ptr )malloc(s*sizeof(struct _cell)); * test ***/
  /*** cell_begin[n]=p=(ptr )calloc(s,sizeof(struct _cell)); * test ***/
  s=CELLU_size;
  //sprintf(iobuff,"cell bank %p  end=%p size=%d\n",p,p+s,s);
  //lwritestr(STDERR,iobuff);
  cell_end[n]=p+s;
  cell_total+=s;
  //printf("s=%d\n",s);
  while(s--){
    CDR(p)=free_cell;
    MARK(p)=FREECELL;
    CAR(p)=a_nil;
    free_cell=p++;
 }
 /** printf("extends end p %x\n",p);  ***/
}

/**** obj   ***/
ptr objaddress(ptr x){
   return  number2str(bignum((long) x),10); /*** int->long 64 bit  ***/
}

ptr s_objaddress(int narg,ptr env){
checknarg(narg-1);
return objaddress(*(stack-1));
}
/****  integer-> print obj ***/
ptr s_obj_print(int narg,ptr env){
 ptr x;
  checknarg(narg-1);
  x=*(stack-1);
 if(SINTP(x)) x=(ptr)GETNUM(x);
 else if(BIGINTP(x)){
    /*** if(mpz_fits_slong_p(BIGNUM(x)))  64bit ***/
   /***  if(mpz_fits_sint_p(BIGNUM(x)))  not sint!!! ***/
      x=(ptr)mpz_get_si(BIGNUM(x));
   /***  else error(E_illegal,x);   ***/
}
else
     error(E_illegal,x);
 if(OBJP(x)){
   prin1(x,STDOUT);
 }
else{
   printf("Not scheme obj %p\n",x);
   prin1(x,STDOUT);  // But!!!
}
 return a_undef;
}

