/*** logical.c
***/
#include "lisp.h"

extern mpz_t mpzwork1,mpzwork2;

ptr Band(mpz_t x,mpz_t y){
  mpz_and(mpzwork1,x,y);
  return mpz_check16(mpzwork1);
}

ptr Bior(mpz_t x,mpz_t y){
  mpz_ior(mpzwork1,x,y);
  return mpz_check16(mpzwork1);
}

ptr Bxor(mpz_t x,mpz_t y){
  mpz_xor(mpzwork1,x,y);
  return mpz_check16(mpzwork1);
}

ptr Bcom(mpz_t x){
  mpz_com(mpzwork1,x);
  return mpz_check16(mpzwork1);
}

ptr Bcount(mpz_t x){  /***  positive x  , count 1  ***/
 unsigned long k;
  k=mpz_popcount(x);
  mpz_set_ui(mpzwork1,k);
  return mpz_check16(mpzwork1);
}

ptr Blength(mpz_t x){  /***  positive x  , size  ***/
 unsigned long k;
  k=mpz_sizeinbase(x,2);
  mpz_set_ui(mpzwork1,k);
  return mpz_check16(mpzwork1);
}


static ptr long_ash(u,v)
  Reg ptr u,v;
{
  Reg INT s,n;
  psh(u);
  psh(v);
  if(SINTP(v)) n=GETNUM(v);
  else{
    n=mpz_get_si(BIGNUM(v));
  }
 if(n<0){   /*  if v<0  */
     mpz_fdiv_q_2exp(mpzwork1,BIGNUM(u),-n); 
 }
 else
       mpz_mul_2exp(mpzwork1,BIGNUM(u),n);  
   u= mpz_check16(mpzwork1);
   stack-=2;
  return u;
}

static ptr ash16(u,v)
  Reg ptr u,v;   /* int  */
{
   Reg int s;
  if(v==ZERO||u==ZERO) return u;
         u=bignum((long)GETNUM(u));
   return long_ash(u,v);
}

ptr gen_ash(int narg, ptr env)
 {
   Reg ptr u=*(stack-2),v;
   v=*(stack-1);
   checknarg(narg-2);
   if(SINTP(u)) return ash16(u,v);
   else if(BIGINTP(u))
       return long_ash(u,v);
   else
      return error(E_notint,u);
 }



