
#include "lisp.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "clread.h"

/**** OS-9
#define  constituent  0
#define  space        1
#define  m_escape    34
#define  s_escape     2
#define  macro        4
#define  non_t_macro  36
#define  illegal      64
#define is_macro(x)   ((x)&macro)
#define is_non_t(x)   (((x)&non_t_macro)==non_t_macro)
#define is_t_macro(x)   (((x)&non_t_macro)==macro)
***/
#define  sh_name  iobuff

extern ptr make_vect_list();
extern void add_tok(ptr );

/** #define close_tok()   GMAKESTR(tokstr,loc_tok) ***/
extern ptr makestring_p();

static ptr srch_name();
//static char sh_name[64];
/***   2020.1.9  read-circle  ***/
static ptr *shenv=NULL;
/**  must call  error, or s_gread  **/
void init_sh(){
  if(shenv==NULL){
      shenv=sysprotect+syspro;
      syspro++;
  }
  *shenv=NIL;
}
//   #=
 ptr  sh_cdef(int narg,ptr env)
  {
    Reg ptr n,x,y,lpath=*(stack-2);  
          /** printf("sh_char lpath %x  subc %x\n",lpath,*(stack-1)); **/
          n=gread(lpath);  // must SINT or SYMBOL
          x=gread(lpath);
          psh(x);
          y=CONS(n,x);
          psh(y);
          *shenv=CONS(y,*shenv); // push (n . x) shenv
          sp_pull(2);
       return  x;
 }
//   #-
 ptr  sh_cref(int narg,ptr env)
  {
    Reg ptr n,x,lpath=*(stack-2);
          /** printf("sh_char lpath %x  subc %x\n",lpath,*(stack-1)); **/
          n=gread(lpath);  // must SINT or SYMBOL
          x=CONS(n,NIL);
          EXATTR(x)=CIRCLEMARK;  //  appear only here.
       return  x;
 }
//
static ptr sh_trans_aux(ptr x){
   EXATTR(x)=0;
   x=assq(CAR(x) ,*shenv);  //  find n=CAR(x)
  if(x!=a_f) return CDR(x);
  return a_f;
}


static ptr sh_trans(ptr a){
   int s,i,n;
   ptr x,*p;
  if(SREGP(a)) return a;
   if(a==a_nil) return a;
  n=ATTR(a);
    if(n==CELL){
        x=CAR(a);
        if(!SREGP(x)){
            if((ATTR(x)==CELL)&&(EXATTR(x)&CIRCLEMARK)){
               CAR(a)=sh_trans_aux(x);
            }
           else
              sh_trans(x);
       }
         x=CDR(a);
        if(!SREGP(x)){ 
            if((ATTR(x)==CELL)&&(EXATTR(x)&CIRCLEMARK)){
               CDR(a)=sh_trans_aux(x);
            }
           else
              sh_trans(x);
       }
      }else if(n==VECTOR){
        p= get_vector(a,&s);
       for(i=0;i<s;i++){
         x=*p;
         if(!SREGP(x)){
            if((ATTR(x)==CELL)&&(EXATTR(x)&CIRCLEMARK)){
               *p=sh_trans_aux(x);
            }
           else
              sh_trans(x);
         }
         p++;
       }
     }else
        ;
   return a;
}
ptr sh_trans_exec(ptr a){
  if(*shenv==NIL) return a;
  return sh_trans(a);
}
//  end circle
//   #<...>
 ptr  sh_undef(int narg,ptr env)
  {
    Reg ptr c,end,lpath=*(stack-2);
    int s=0;
     end=MAKECHAR('>');

      while(1){
        c=read_char(lpath);
        if(c==SEOF)
         error(E_syntax_read,c);
        if(c==end)
          break;
        sh_name[s]=CHAR_CODE(c);
        s++;
        if(s>4900)   // <MAXIO 
         error(E_syntax_read,c);
     }
      sh_name[s]='\0';
      if(s==0) return a_undef;
      if(strcmp(sh_name,"unbdd")==0)  return a_unbdd;
      if(strcmp(sh_name,"eof")==0)  return SEOF;
      return CMAKESTR(sh_name);
}

int read_digit(stream)
  Reg ptr stream;
 {
    Reg int n=-1,x;    /*** return -1 if Not Exist!!! **/
     x=(long)read_char(stream);
      if(!isdigit(x))
        {
          goto owari;
        }
     n=x-'0';
      while(isdigit(x=(long)read_char(stream)))
       {
         n=n*10+x-'0';
       }
   owari:
     unreadchar(x,stream);
          return n;
 }

static ptr special_c(p,n)
  Reg char *p;
  Reg int n;   /***  moji count >1 **/
{
  Reg ptr ch;
  Reg char *q=p;
  Reg int i=n;
      /*** 89.8.31   
          name may be Newline or NEWLINE  (Mac-Lisp) ,newline
          So we needs both case!!!
          i.e.  new name no touroku ha izurekano
               form must!
         91.9.9  name is string, &&
                UPPERCASE
      ****/
   /***
    while(i--)
     {
       *q++=toupper(*q);
     }
   ***/
 if((ch=srch_name(p,n))!=a_f) return ch;
  return  error(E_notchar,GMAKESTR(p,n));
}

static ptr srch_name(p,n)
  Reg Uchar *p;
  Reg int n;   /***  moji count >1 **/
 {
  Reg ptr x,name,alist;
  unsigned char *q;
  Uint k;
    alist=ATOMVAL(a_name_char);
    
    while(alist!=a_nil)
     {
       x=CAR(alist);
       name=CAR(x);
       q=get_string(name,&k);
       if(k==n)
        {
          if(scm_strcmp(p,q,n))
               return CDR(x);         
        }
       alist=CDR(alist);
     }
  return a_f;
 }

static ptr srch_char(ch)
  Reg ptr ch;
 {
      /*** return name  ***/
  Reg ptr x,alist;
    alist=ATOMVAL(a_name_char);
    return rassq(ch,alist);
 }

 /***   sharp-dispatch functions    (func stream subchar)
      2引数とする。
 ****/
 ptr  sh_char(int narg,ptr env)
    
  {
    Reg int n;
    Reg ptr x,lpath=*(stack-2);  /**** needs if sh_char is 
                         used directly, not with read!!!***/
          /** printf("sh_char lpath %x  subc %x\n",lpath,*(stack-1)); **/
          x=read_char(lpath);
          n=CHAR_CODE(x);
          if(n>127||!isalpha(n))    /*** 89.11.24 for #\^L  ***/
             return x;
          unreadchar(x,lpath);
         /*** may be char NAME ***/
       loc_tok=0;
       extoken(lpath);
      /*** if(ATOMVAL(a_read_suppress)!=a_nil) return a_nil; ***/
       if(loc_tok==0)
         error(E_syntax_read,a_undef);
       else if(loc_tok==1)
          return x;  /** *tokstr);***/
       else
          return special_c(tokstr,loc_tok);
       return x; /* Never reach */
     }

 ptr  sh_logic(int narg,ptr env)

  {
    Reg int n;
    Reg ptr x,lpath=*(stack-2);  /**** needs if sh_char is
                         used directly, not with read!!!***/
         /*  printf("sh_logic lpath %x  subc %x\n",lpath,*(stack-1));*/
          x=read_char(lpath);
          n=(long)get_type(x);
          if(n&space||is_macro(n)) {
             unreadchar(x,lpath);
             if(CHAR_CODE(*(stack-1))=='t') return a_t;
             else
               return a_f;
           }
         return error(E_syntax_read,x);
   }

ptr sh_radix(int narg,ptr env)
    
  {
    Reg int x;
    Reg ptr ch;
    Reg ptr lpath=*(stack-2);
         /* printf("sh_radix lpath %x  subc %x\n",lpath,*(stack-1)); */
   loc_tok=0;
   ch=*(stack-1);
   x=CHAR_CODE(ch);
    if(x=='b')
     {
       return g_radix(lpath,2,ch);
     }
    else if(x=='o')
     {
       return g_radix(lpath,8,ch);
     }
    else if(x=='x')
     {
       return g_radix(lpath,16,ch);
     }
    else 
     {
         /*** x=='r'***/
       return error(E_syntax_read,ch);
       /*** if(arg[2]==a_nil) error(E_syntax_read,ch);
       return g_radix(GETNUM(arg[2]),ch);
       ***/
     }
    }

/***
 ptr sh_func(int narg,ptr env)
    
  {
      ***    #'(func)  ***
       return CONS(a_function,CONS(g_read(*(stack-1)),a_nil));
   }
***/

 ptr sh_vect(int narg,ptr env)
  {
    Reg ptr x;
    Reg ptr lpath=*(stack-2);
       /****   #(....)     vector read   ***/
          unreadchar(*(stack-1),lpath);
       x=g_read(lpath);
      psh(x);
         x=make_vect_list(x);
         pull();
         return x;
 }
 ptr sh_array(int narg,ptr env)
   /****   #a(......)   ***/ 
  {
    Reg ptr x;
    Reg ptr lpath=*(stack-2);
       x=g_read(lpath);
      psh(x);
         x=make_matrix_list(x);
         pull();
         return x;
  }
/*** 2004.11.30  hash read! ***/
ptr sh_hash(int narg,ptr env)
   /****   #H(......)   ***/
  {
    Reg ptr x;
    Reg ptr lpath=*(stack-2);
       x=g_read(lpath);
      //ATTR(x)=AHASH;
      ATTR(x)=HASH;
     return x;
  }


   /****   #S(......)   ***/
/***
 ptr sh_structure(int narg,ptr env)
  {
    Reg ptr x,name,func;
    Reg ptr lpath=*(stack-2);
       x=g_read(lpath);
      psh(x);
       name=CAR(x);
       name=PNAME(name);
       func=make_str_c("make-");
       psh(func);
       *(stack-1)=func=str_append(func,name);
       func=intern(func,a_undef);
       *(stack-1)=ATOMVAL(func);
       psh(CDR(x));
         x=s_apply(2,a_nil);
       sp_pull(3);
     return x;
  }
****/
 ptr sh_structure(int narg,ptr env)
  {
    Reg ptr x,name,offset,func;
    Reg ptr lpath=*(stack-2);
       x=g_read(lpath);
      psh(x);
       name=CAR(x);
      /***  offset=structure_offset(name); ***/
       name=PNAME(name);
       /** func=make_str_c("make-"); ***/
       func=make_str_c("make-s-");
       psh(func);
       *(stack-1)=func=str_append(func,name);
       func=intern(func,a_undef);
       x=*(stack-2)=SCONS(func,CDR(x));
       /** x=meval(x,env);   1.99***/
       x=vm_eval(x,env);   /*** V2.0  2010.5.30  ***/
       sp_pull(2);
     return x;
  }

ptr sh_skip(int narg,ptr env)
   
 {
   Reg ptr stream=*(stack-2);
   Reg ptr x,y;
   Reg int  n,m;
  loop:
        x=read_char(stream);
        if(x==SEOF) error(E_syntax_read,MAKECHAR('#'));
        n=CHAR_CODE(x);
        if(n!='|'&&n!='#') goto loop;
    loop2:
        y=read_char(stream);
        m=CHAR_CODE(y);
        if(y==SEOF) error(E_syntax_read,MAKECHAR('#'));
        if(m!='|'&&m!='#') goto loop;
        if(x==y) goto loop2;
        if(n=='#'&&m=='|') 
          {
             sh_skip(narg,env);
             goto loop;
           }
        /* if(x=='|'&&y=='#') */
     return a_undef;
 }

/***  for regular expression pattern str ***/
/***   \" -> \"  Only!   ***/
ptr sh_regstr(int narg,ptr env)

 {
   Reg ptr stream=*(stack-2);
   Reg ptr x,y;
   Reg int  n,m;
    loc_tok=0;
  loop:
        x=read_char(stream);
        if(x==SEOF) error(E_syntax_read,MAKECHAR('#'));
        n=CHAR_CODE(x);
        if(n=='"'){
            x=close_tok();
            if(a_auto_regexp==a_f) return x;
            psh(x);
            *(stack-1)=x=funcall(a_auto_regexp,1,a_nil);
            x=CONS(x,a_nil);
            x=SCONS(a_quote,x);
            pull();
            return x;
         }
        if(n!='\\'){
           add_tok(x);
           goto loop;
       }
        y=read_char(stream);
        m=CHAR_CODE(y);
        if(y==SEOF) error(E_syntax_read,MAKECHAR('#'));
        if(m=='"'){
           add_tok(y);
           goto loop;
         }
           add_tok(x);
           add_tok(y);
        goto loop;
     return a_undef;
 }

/***  for Math or other transform 2020.1.10  ***/
/***   #[ func  ...  ]#   -> (func string)   ***/
ptr sh_func(int narg,ptr env)
 {
   Reg ptr stream=*(stack-2);
   Reg ptr x,y,f;
   Reg int  n,prev;
    f=gread(stream);  //must function
    if(SREGP(f)||  !SYMBOLP(f))
         error(E_syntax_read,f);
    loc_tok=0;
  loop:
        x=read_char(stream);
        if(x==SEOF) error(E_syntax_read,MAKECHAR('['));
        n=CHAR_CODE(x);
        if(n==']'){
             y=read_char(stream);
             if(y==SEOF) error(E_syntax_read,MAKECHAR(']'));
             if(CHAR_CODE(y)=='#'){ 
                x=close_tok();
                psh(x);
                 x=funcall(f,1,a_nil);
                pull();
              return x;
             }
           add_tok(x);
          unreadchar(y,stream);  //  may be ]
           //add_tok(y);
         }
       else
           add_tok(x);
     goto loop;
   return a_undef;
 }



/*** #!/bin/ss   for shell script of ss ***/
ptr sh_shell(int narg,ptr env)
 {
   Reg ptr stream=*(stack-2);
   Reg ptr x,y;
   Reg int  n,m;         
  loop:   
        x=read_char(stream);
        if(x==SEOF) return a_undef;
        n=CHAR_CODE(x);
        if(n!='\n') goto loop;
     return a_undef;
 }

ptr sh_complex(int narg,ptr env)
   
 {
   Reg ptr stream=*(stack-2);
       return list_complex(g_read(stream));
  }
/****
sh_bitv(int narg,ptr env)
   
 {
    stream=*(stack-1);
       return g_bitv(arg[1],arg[2]);
  }
**/
/****  bit-vector read 91.3.14 ***/
/***
g_bitv(ch,size)
  Reg ptr ch,size;
 {
    Reg int n,bit,ct,len;
    Reg unsigned char c,*p=tokstr,*q;
   loc_tok=0;
        extoken();
      if(ATOMVAL(a_read_suppress)!=a_nil) return a_nil;
      if((n=is_bit_number(tokstr))==ERR)
             error(E_syntax_read,ch);
      if(size==a_nil) len=n;
       else
            len=GETNUM(size);
      if(n>len) error(E_overlen,close_tok());
       q=FWSTR(ch=GMAKEARRAY(1,len,1));
       bit=0;
       ct=8;
      while(len--)
        {
          if(*p) c=*p++;
           bit=(bit<<1)+(c-'0');
           ct--;
           if(ct==0)
            {
              ct=8;
              *q++=bit;
             }
         }
        if(ct<8) *q=bit<<ct;
     return ch;
 }
is_bit_number(p)
  Reg char *p;        ***  0,1 **
{
  Reg int ct,c,n=0;
    ct=loc_tok;
    while(ct--)       ** =*p++) **
     {
       c=*p++;
       n++;
       if(c!='0'&&c!='1') return ERR;
     }
      return n;
 }

 **/ 
/***
sh_symb(int narg,ptr env)
   
 {
              ** x==':')    90.6.17  uninterned **
    stream=*(stack-1);
   loc_tok=0;
       extoken();
      if(ATOMVAL(a_read_suppress)!=a_nil) return a_nil;
       if(loc_tok==0)
         error(E_syntax_read,arg[1]);
     return MAKESYMBOL(tokstr);
  }
***/
/***
sh_eval(int narg,ptr env)
   
 {
   Reg ptr x;
       x=g_read(*(stack-1),a_t);
      if(ATOMVAL(a_read_suppress)!=a_nil) return a_nil;
       return eval(x,a_nil);
  }
***/
/***
ptr feature(x)
  Reg ptr x;
 {
  Reg ptr p,form;
   if(SYMBOLP(x))
     return PRED((ptr)member(x,ATOMVAL(a_features))!=a_nil);
   psh(p=form=CONS(CAR(x),a_nil));
      while((x=CDR(x))!=a_nil)
       {
          p=CDR(p)=CONS(feature(CAR(x)),a_nil);
       }
    x=eval(form,a_nil);
    pull();
    return x;
  }
***/
/***
sh_plus(int narg,ptr env)
   
 {
   Reg ptr x,cmp;
     if(C_CODE(arg[1])=='+') cmp=a_t;
     else
         cmp=a_nil;
     x=g_read(*(stack-1),a_t);
      if(ATOMVAL(a_read_suppress)!=a_nil) 
         {
           return g_read(*(stack-1),a_t);
         }
     psh(x);
     if(feature(x)==cmp)
        {
            x=g_read(*(stack-1),a_t);
           pull();
           return x;
        }
        else
        {
          ATOMVAL(a_read_suppress)=a_t;
            g_read(*(stack-1),a_t);
          ATOMVAL(a_read_suppress)=a_nil;
           pull();
           return value0();
        }
 }
sh_label(int narg,ptr env)
   
 {
   Reg ptr x,g,*stack;
   if(ATOMVAL(a_read_suppress)!=a_nil) return value0();
   if(arg[2]==a_nil)
      error(E_syntax_read,arg[1]);
    *readlabel=CONS(CONS(arg[2],g=CONS(a_nil,a_nil)),*readlabel);
   x=g_read(*(stack-1),a_t);
   if(x==g)
      error(E_syntax_read,arg[2]);
   CDR(CAR(*readlabel))=x;
   supersubst(x,g,x);
       return x;
 }
sh_label_ref(int narg,ptr env)
   
 {
   Reg ptr x,n;
      if(ATOMVAL(a_read_suppress)!=a_nil) return a_nil;
     x=*readlabel;
     n=arg[2];
     ** assoc **
     while(x!=a_nil)
      {
        if(CAR(CAR(x))==n) break;
        x=CDR(x);
      }
     if(x==a_nil) error(E_syntax_read,n);
     return CDR(CAR(x));
 }
  ***/

