/****  sint.c
     SINT  math 
  2014.5.8 modified for 64bit-OS
      and Bug fix!
***/
/***  correct check overflow!!! ***/
#define  SINT_C

#include "lisp.h"
#include <stdio.h>

#ifdef SYSTEM64
#define MSB        0x8000000000000000  //64bit MSB 
#else
#define MSB     0x80000000  //32bit MSB 
#endif
extern mpz_t mpzwork1,mpzwork2;

ptr add(ptr p,ptr q){
Reg INT n,m;
  //printf("add enter p=%p  q=%p\n",p,q);
  n=((INT)p)>>2;
  m=((INT)q)>>2;
      n+=m;
  if(n>=SINTMIN&&n<=SINTMAX){
       return (ptr)((n<<2)|1);
   }
  return bignum(n);
}

ptr sub(ptr p,ptr q){
Reg INT n,m;
  //printf("add enter p=%p  q=%p\n",p,q);
  n=((INT)p)>>2;
  m=((INT)q)>>2;
      n-=m;
  if(n>=SINTMIN&&n<=SINTMAX){
       return (ptr)((n<<2)|1);
   }
  return bignum(n);
   /***  this is bad if q==SINTMIN
     q=minus(q);
    return add(p,q);
  **/
}

ptr mul(ptr p,ptr q){
INT n,m;
int sig=1;
  n=GETNUM(p);
  if(n<0){
      sig=-sig;
      n=-n;
  }
  m=GETNUM(q);
 if(m<0){
      sig=-sig;
      m=-m;
  }
#ifdef SYSTEM64
//  n,m are 62 bit max and double has 52 bit
  //   2^10=1024 , 512 is enough  but
 if(((double)(n+1024)*(double)(m+1024))>SINTMAX){
#else
 if(((double)(n+1)*(double)(m+1))>SINTMAX){
#endif
   if(sig<0) n=-n;
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
   mpz_mul(mpzwork1,mpzwork1,mpzwork2);
   return mpz_check16(mpzwork1);
 // printf("mul sint unsafe sig=%d n=%lx m=%lx  n*m=%lx  return p=%p\n",sig,n,m,n*m,p);
  }
 if(sig<0) n=-n;
  // p=MAKESINT(n*m);
  //printf("mul sint safe sig=%d n=%lx m=%lx  n*m=%lx  return p=%p\n",sig,n,m,n*m,p);
 return MAKESINT(n*m);
}

ptr mod(ptr p,ptr q){
INT n,m;
 n=GETNUM(p);
 m=GETNUM(q);
 n=n%m;
 if(m>0&&(n<0)) n+=m;
 if(m<0&&(n>0)) n+=m;
 return MAKESINT(n);
}

ptr remain(ptr p,ptr q){
INT n,m;
 n=GETNUM(p);
 m=GETNUM(q);
 return MAKESINT(n%m);
}

ptr intdiv_sint(ptr p,ptr q){
INT n,m,r;
  n=GETNUM(p);
  m=GETNUM(q);
  r=n%m;
  if(r==0) return MAKESINT(n/m);
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
  return mpz2rational(mpzwork1, mpzwork2);
}

/** quotient ***/
ptr div_sint(ptr p,ptr q){
INT n,m;
  n=GETNUM(p);
  m=GETNUM(q);
   return MAKESINT(n/m);
}

