;;;;  comppiler-load 
;;;; only load 
;;;;  define
;;;;  define-syntax   also needs  04.5.1
;;;;  package   etc.  needs     04.5.14
;;;;  require,provide,remove-module
;;;;
;;;(in-package "compiler")

(define (compiler-load-define file)
   (let* ((s 0)(ext 0))
       (set! s (find-source file #t)) ;;;  find-scm  is bad 
       (if (not s)
            (set! s (find-source file))
       )
       (if (not s) (error E_open file))  ;;; can't load
       (set! ext (cdr (file-sepa-ext s)))
      ;;;(format #t "debug-1:~~s ~s ~%" file ext)
       (if (equal? ext ".sr2")
           (load s)   ;;; load everything
           (compiler-load-define-only s)
       )
))

(define (compiler-load-define-only  file)
  (let ((s 0)(f 0)(out #f)(out-file 0)(xx 0)(memo sys:*package*))
     (set! s (open-input-file file))   ;;;;(find-source file)))
     (set! out-file (make-temp-file))  ;;;lib.scm  get-->make
        (set! out (open-output-file out-file))
      ;;;     (format #t "debug0:~~s ~%" file)
         (do ((x (read s)(read s)))
           ((eof-object? x)
                  (close-input-port  s)
                )
           (format #t "debug1:~s ~%" x)
           (when (pair? x)
               (set! f (car x))
               (cond ((eq? f 'load)  ;;;; this file use some value of previous define
                            (compiler-load-define (cadr x))
                           ;;; But this cause a change of Basic Data
                           ;;; specially if we compile, compiler system!
                           ;;;   opt-vector's are changed!
                         )  ;;;;load file
                     ((eq? f 'compiler-eval) 
                         (format out "~s~%" (cons 'begin (cdr x))))
                     ((eq? f 'compiler-not-eval) )
                     (else 
                          ;;; (write-out x out #f)
                         )     
                )
             )
         )
      (close-output-port  out)
      (load out-file)
      (remove-file out-file)
    (set! sys:*package* memo)
))

(define (write-out x out expanded)
  (if (pair? x)
       (write-out-main  x out expanded)
  )
)

(define (write-out-main x out expanded)
  (let ((xx 0)(f 0))                
       (format #t "write-out-main ~s~%" x)
       (set! xx #f)
       ;;;   04.4.23
       ;;;      (set! x (macro-expand-rec  x)) 

       (set! f (car x))
       (set! xx (special? f));;; f may be alias
       (if xx (set! f xx))

       (cond ((eq? f 'begin)
                (set! x (cdr x))
                (while (pair? x)
                  (write-out (car x) out expanded)
                  (set! x (cdr x))
                )
              )
            ((eq? f 'if)   ;;;;  04.5.7   (if xx (define ...))  in top-level
                  (write-out (cadr x) out expanded)
                  (if (pair? (cddr x))
                     (write-out (caddr x) out expanded)
                  )
                )
            ((eq? f 'define)
                ;;;  define only functions    04.5.7
                (if (pair? (cadr x))
                     (format out "~s~%" x)
                   ;else
                    (begin    ;;;; we ignore (define x (let* .... (lambda ....)) etc.)
                      (set! xx (caddr x))
                      (if  (pair? xx)
                           (begin
                             (set! xx (special? (car xx)))
                             (if (or (eq? xx  'lambda)(eq? xx 'macro))
                                  (format out "~s~%" x)
                             )
                           )
                      )  
                    )
                 )
               )
            ((eq? f 'define-syntax)
                (format out "~s~%" (macro-expand-rec x ()))  )
            ((eq? f 'define-macro)
                (format out "~s~%" (macro-expand-rec x ()))  )
            ((eq? f 'defstruct)
                (format out "~s~%" (macro-expand-rec x ()))  )
            ((or  (eq? f 'in-package) (eq? f 'export)(eq? f 'use-package)
                 (eq? f 'intern)(eq? f 'shadowing-intern)(eq? f 'unintern)
                 (eq? f 'unuse-package) (eq? f 'provide)(eq? f 'remove-module))
                 ;;;(catch (eval x))  toriaezu
                  (eval x)
                (format out "~s~%" (macro-expand-rec x ()))  )
            ((eq? f 'require)    ;;; require can't eval include define
                 (load-form x)
                ;;;;(format out "~s~%" x) ;;; Need?
              )
            ((pair? x)   
               (if (not expanded)
                      (write-out  (macro-expand-rec x () ) out #t)
                )
           )
          (else
              )
        )
))

