;;;;  compile
;;;;   2003.11.23
;;;
;;;;;  最終整形
;;;   :LAMBDA-BEGIN block size
;;;   :LAMBDA-BIND (..)
;;;   :ALLOC n (if n>0)
;;;
;;;  :LAMBDA-END ->
;;      :EXIT block
;;;      :MAKE-LAMBDA size    or :MAKE-MACRO size
;;;
(in-package "compiler")
(define   (final-comp )
   (let ((v *comp-vector*)(n *comp-size*)(x 0)(macro 0)
            (lambda-stack ()) (top 0)(block #f)(alloc 0) )
     (do ((i 0))
         ((<= n i) )
         (set! x (vector-ref v i))
         (set! top (car x))
         (cond  ((eq? top :LAMBDA-BEGIN)
                    (set! alloc (car (cddr (cddr x))))
                    (set! macro (eq? (caddr  x) :MACRO))
                    (set! block  (cadr x))
                    (push (cons block macro) lambda-stack)
                    (if (> alloc 0)
                       (insert-comp (+ i 2) (list :ALLOC alloc))
                    )
                  )
                ((eq? top :LAMBDA-END)
                    (set!  block (pop lambda-stack))
                    (set! macro (cdr block))
                    (set! block (car block))
                    (vector-set! v i (list :EXIT block))
                    (if macro 
                          (set! macro :MAKE-MACRO)
                          (set! macro :MAKE-LAMBDA)
                    )
                    (insert-comp (+ i 1) (list macro block)) ;;; alloc is dummy
                  )
               (else )
          )
         (if (eq? top #f)
            (set! i n)
          ) 
         (set! i (+ i 1))
      )
))


;;;;  IF count  最終処理
;;;;  破壊的
(define (if-syori comp-list)
  (let ((x 0)(op 0)(cl comp-list))
    (while (pair?  cl)
      (set! x (car cl))
      (set! op (car x))
      (if  (or (eq? op :IF) (eq? op :JMP))
           (jmp-count!  cl)
      )
      (if (eq? op :LAMBDA-BEGIN)
           (lambda-count! cl)
      )
     (set! cl (cdr cl))
    )
   comp-list
)) 

(define (lambda-count! cl)
  (let ((op (car cl)) (x 0) (n 0)(lab 0)(op2 0))
         (set! lab (cadr op))
     (while (and (pair?  cl) (> n -5))
     (set! cl (cdr cl))
      (set! x (car cl))
      (set! op2 (car x))
      (when (and (or (eq? op2  :MAKE-LAMBDA)(eq? op2 :MAKE-MACRO)) (eq? (cadr x) lab))
            (set-car! (cddr op) n)
            (set-car! (cdr x) n)
            (set! n -100)  ;;;; break
      )
     (set! n (+ n (count op2 x)))
    )
))

(define (jmp-count! cl)
  (let ((op (car cl)) (x 0) (n -2)(lab 0)(op2 0))
     ;;; not  count JMP operation itself so n=-2
      (if (eq? (car op) :IF)
         (set! lab (caddr op))
         (set! lab (cadr op))
      )
     (while (and (pair?  cl) (> n -5))
      (set! x (car cl))
      (set! op2 (car x))
      (when (and (eq? op2  :LABEL) (eq? (cadr x) lab))
           (if (eq? (car op) :IF)
             (set-cdr! (cddr op) n)  
             (set-cdr! (cdr op) n)  
           )
            (set! n -100)  ;;;; break
      )
     (set! n (+ n (count op2 x)))
     (set! cl (cdr cl))
    )
))

(define (count op x)
  (cond ((eq? op :LABEL ) 0)
        ;;;((eq? op :warning ) 0)
        ((eq? op :FUNC) 1)
        ;;;((eq? op :FUNC-TAIL) 1)
        ((eq? op :BLOCK-IN) 1)
        ((eq? op :BLOCK-OUT) 1)
        ((eq? op :EXIT) 1)
       ;;; ((eq? op :LAMBDA-END) 1)
        ((eq? op :LAMBDA-BIND) 3)
        ((eq? op :STACK-NARG) 1)
        ((eq? op :LOAD) 
            (if (pair? (cddr x)) 2 1)
          )
        ((eq? op :CALL/CC) 1)
        (else 2)
  )
)
        

