;;; usage:  (get-file-name)
;;;         (get-file-name "*.sgf")
;;;         (get-file-name "*.scm" "*.stk" "*.lsp")
;;;  if no selection,   #f  is returned
;;;  system cwd may be changed in this dialog!!!
;;; 
;;;      2002.5.20  
;;;     2002.8.20    chdir version start
;;;
;;;  2005.1.7  entry glob add
;;;  2005.3.21   Double click version
;;;
;;;(provide "get-file")
(require "get-file-base")
(in-package "get-file")
(define *file-non* "Select File")

(define (get-file-name . ext)
  (let* ((s 0) 
        (dir  (gen-toplevel '.getfile))
        (file-name  (tk-name dir ".name"))   ;;; file name
        (dir-ok  (tk-name dir ".ok"))
        (dir-cancel  (tk-name dir ".cancel"))
        (file-var (string->symbol (substring (symbol->string dir) 1 :end)))
        (getf (make-GETF))
        (file-lb 0)
        (memo (getcwd))
        )
    (if (null? ext) (set! ext '("*" ".*" ) ) )  ;;;;  .* are hidden for *
    (wm 'title  dir  "File Select window")
    ;;;(wm 'geometry dir "500x430+80+80")
     ;;(grid 'rowconfigure dir 2 :weight 1)
     ;;;(grid 'columnconfigure dir 0 :weight 1)
     (set-GETF getf :top dir :ext ext :var file-var)
     ;;;(set! getf(make-files-win dir ext))
     (make-files-win getf)
     (label file-name :text *file-non* :textvariable file-var 
          :bg 'snow :width 25  :height 2)
     ;;;(grid file-name  :sticky 'ew)
     (button dir-ok :text "OK" :command `(destroy ,dir))
     (button dir-cancel :text "CANCEL" :command 
           (lambda() (symbol-value-set file-var *file-non* )(destroy dir))  )
     (grid file-name dir-ok   :sticky 'ew ) 
     (grid  dir-cancel :column 2 :sticky 'e )   ;;;  :sticky 'ew )
     (dir-reset getf)
    (set! file-lb (GETF-win getf))
    (bind file-lb   "<Button-1>" (lambda (y)
           (get-file-ypos  y getf) )  )

    (bind  file-lb  "<Return>" (lambda () (destroy dir)))
     (tkwait 'window dir )
     ;;;  below not eq? because tklink copy string
     (if (equal? (symbol-value file-var) *file-non*) (set! s #f )
          (begin 
             (set! s (symbol-value file-var))
             ;;;;(set! s (if (number? s) (number->string s) s))
             (set! s (tk-string (getcwd) #\/ s)) 
          )
     )
   (chdir memo)
  s
))

(define (get-file-ypos  y getf)
  (let* (( file-lb (GETF-win getf))
         ( file-var (GETF-var getf))
         ( allfile  (GETF-allfiles  getf))
         ( files  (GETF-files  getf))
         (i  (funcall file-lb  'nearest y  ))
         (file "")
        )
     ; (format #t "~s ~s ~%" i y)
     ;;;(set! file (funcall file-lb 'get i))
     (set! file (list-ref allfile i))
     (if (member file files)
         ;;;(symbol-value-set file-var (tk-string (GETF-cwd getf) #\/ file))
         (symbol-value-set file-var file)
         (symbol-value-set file-var *file-non*)
     )
     (focus file-lb)
     (update)
)) 

(export 'get-file-name)
(use-package "get-file" "ss")

;;; test
;;;(get-file-name)
;;;(bye)



