;;;  http-proto.ss
;;;  2005.1.21
;;;   from http.ss separated
;;;
(in-package "http")
(require "http-base")
(define *Date*  "")  ;;; no need
;;;;;;;
;;; (define *Proxy* '("66.250.69.2" 81))     ;;; IP port   use as default proxy
#|
(define (http host . msgs )
  (apply http-proto "http" host msgs)
)
|#

(define (http-proto dld proto  host . msgs )
  (let* ((soc #f)(net #f)(err 0)(msg 0)  (tmp 0)(out 0)(status 0))
     (set! *recv* ())
     (write-status "Connecting..." dld)
     (set! err (catch (begin (set! net (netport proto host))
             (set! soc (socket-connect net)))))
    ;; (format #t "http-proto: net ~s~%" net)
      (if err
         (begin
  ;;;   (format #t "http-proto: err ~s~%" soc)
           (write-status
             (format #f "connection failed! ~s ~s" host net)
             dld
           )
          (set-DLD dld :dlstate 'ERR)   ;;; CERR?
         )
         (begin
           (set-DLD dld :soc soc)
  ;;; (format #t "http-proto: dld ~s~%" dld)
           (while (pair? msgs)
              (set! msg (pop msgs))
              (format soc "~a~%" msg )
           )
          (if (get-header-status  soc  dld)   ;;; may be connection closed!!!
            (begin
              (set! out (open-output-str (make-string 256)))
              (set-DLD dld :out out)
              (set-DLD dld :dlstate 'ACT)
              (get-header soc out tmp  dld)
            )
            (begin
              (write-status
                 (format #f "connection closed by host!!! ~s"
                      host )
                  dld
              )
              (set-DLD dld :dlstate 'ERR)
            )
         )
       )
     )
   dld
))

(define (get-header-status  soc  dld)
  (let* ( (msg #\a)  (state 0))
    (clear-header dld)  ;;;; clear www-header

     ( insert-header  (DLD-url dld) dld )
     (set! msg (read-line soc))
   (if (eof-object? msg)
        #f
      (begin
        (insert-header  msg dld)
        (set! state (string->number (substring (regexp msg #"\s\d+") 1 :end)))
        (write-status msg dld)
        (set-DLD dld :status state)
        state
      )
   )
))

(define (get-header  soc out file  dld)
  (let* ( (status #t)(msg #\a) (ishtml (DLD-ishtml dld))
           (content "") (step 0) (Leng 0)
           (regnum (regexp->nfa #"\s\d+"))
         )

    (while (not (equal? msg ""))
            (set! msg (read-line soc))
            (cond ( (string-index "Content-Length:" msg  :nocase )
                     (set-DLD dld :content-length
                       ;;;;(string->number (substring (regexp msg #"\s\d+") 1 :end)))   )
                       (string->number (substring (regexp msg regnum) 1 :end)))   )
                  ( (string-index "Content-Type:"  msg :nocase)
                        (set! content (substring msg 14 :end))  
                        (set-DLD dld :content-type content)  )
                  ( (string-index "Last-Modified:" msg :nocase)
                        (set-DLD dld :last-modified (substring msg 15 :end))  )
                  ( (string-index "Content-Encoding:" msg  :nocase)
                        (set-DLD  dld :encoding (substring msg 18 :end))  )
                  ( (string-index "Mime-Version:" msg  :nocase)
                       (set-DLD dld :mime-version (substring msg 14 :end))  )
                  (else )
             )
            ;;;(format #t "~s~%" msg)
         (insert-header  msg  dld)
    )
   ;;;(set-DLD dld  :binary (and (DLD-object dld) (not (regexp content #"html" :nocase))))
   (when  (and (not ishtml ) (regexp content #"html" :nocase))
        (set! ishtml #t)
        (set-DLD dld :ishtml #t))  ;;;;  may be error
   ;;;(format #t "get-header ~s~%" file)
   (inc *DL-num* )
   (set! Leng (DLD-content-length dld) )
   (set! step (ceiling (/ Leng  20)))  ;;; 5%
   (if (= step 0) (set! step 5000))
   (DL-win-out  dld  0 Leng 'ACT )
   (set! *DL-accept*  #t)
   (if ishtml
      (set! status (get-html-msg  soc out 0 step Leng  dld))   
      (set! status (get-msg  soc out 0 step step Leng  dld))   
   )
   status
))

(define (get-html-msg  soc out len step Leng  dld)
  (let* ((cancel #f)(ready #t) (cont #t)(msg #\a) (work step) (linect 0) )
    (while cont
       (if (not *DL-enable*)
           (set! cont #f)
         (when (member dld *DL-cancel*)
           (set! cont #f)
           (set! cancel #t)
           (set! *DL-cancel* (remove dld *DL-cancel*))
         )
       )
       (if   cont  ;;;(and cont (char-ready? soc))
          (begin
            (set! msg (read-line soc))   ;;;; 
            (if (not (eof-object? msg))
              (begin
                (display msg  out)
                (newline out)
                (inc linect)
                (inc   len (string-byte-length msg))
                (inc len)   ;;;;  newline
                (when (>=  len work)
                   ;;(format #t "recv : ~s/~s~%"  len Leng)
                     (DL-win-out dld len Leng 'ACT)
                     (inc work step)
                    (update)
                )
              )
              (set! cont #f)
            )
          )
         (set! cont #f)
       )
    )
    (if (and (< len Leng) (>= (+ len linect) Leng)) (inc len linect))
      (get-msg-end dld soc out msg len Leng)
))

(define (get-msg  soc out len work step Leng  dld)
  (let* ((cancel #f) (cont #t)(msg #\a) (byte  0) )
  (DL-win-out dld len Leng 'ACT)
    (while cont
       (if (not *DL-enable*)
           (set! cont #f)
         (when (member dld *DL-cancel*)
           (set! cont #f)
           (set! cancel #t)
           (set! *DL-cancel* (remove dld *DL-cancel*))
         )
       )
       (set! byte (char-ready? soc))  ;;;; byte may be 1 and that is EOF
       ;;;(format #t "ready ~s " byte) 
      ;;;;  (if (and byte (not (number? byte) )) (set! byte 1))
       (if  (and cont byte)
          (while (and cont (> byte 0))
            (set! msg (read-byte-char soc))   ;;;; for 1-byte read
            (dec byte)
            (if (not (eof-object? msg))
              (begin
                (display msg  out)
                (inc len)
              )
              (set! cont #f)
            )
            (when (>=  len work)
                  ;;; (format #t "recv : ~s/~s step ~s~%"  len Leng step)
                     (DL-win-out dld len Leng 'ACT)
                     (inc work step)
                    (update)
            )

          )
         (set! cont #f)
       )
  )
  (if (or cancel (eof-object? msg))
      (get-msg-end dld soc out msg len Leng)
      (after 100  (lambda() (get-msg  soc out len work  step Leng dld)))
   )
))

(define (get-msg-end dld soc out msg len Leng)
  (let* ( (request (DLD-request dld))(ishtml (DLD-ishtml dld))
          (allmsg 0)
          (obj (DLD-object dld)) (bin (DLD-binary dld))
          (cgi (DLD-cgi dld)) )
       (format #t "get-msg end:~s bin ~s obj ~s ishtml ~s~%" msg bin obj ishtml)
          (close-port soc)
          (set! allmsg (close-port out))
           (if (and (eof-object? msg) (>= len Leng))
            (begin
               (if (and ishtml bin  (string-index "." obj))
                 ;;; req is object but return html
                 (DL-win-out dld len Leng 'ERR)
                 ;;; else
                 (DL-win-out dld len Leng 'END)
               )
            )
            (DL-win-out dld len Leng 'STP)
        )

          (if (and (not (equal? request "HEAD")) (> len 0))
            (if ishtml
              (begin
                 (clear-html dld)
                 (trans-msg-str  allmsg dld)
              )
              (save-str allmsg obj dld)
            )
           ;;;(remove-file file)
          )
        ;;;(format #t "recv end id=~s obj ~s: ~s/~s~%" id obj len Leng)
        (set-DLD dld :out #f) ;;; for gbc
        (dec *DL-num*)
))


