;;;  05.2.17
;;;;   for <table >
;;;
(in-package "http")
(define (get-tag-row row )
  (let* ((table (car (HTMODE-table-stack *htmode*))) 
         (html *text-win*)
         (tag-row (TABLE-tag-row table))
         (x 0)
        )
    (set! x (assq row tag-row))
    (if x
         (set! x (cdr x))
         (begin
           (set! x (tk-name "tagrow" row))
           (funcall html 'tag 'configure x)
           (push (cons row x) tag-row)
           (set-TABLE  table :tag-row tag-row) 
         )
     )
  x
))

(define (get-tag-col  col)
  (let* ( (table (car (HTMODE-table-stack *htmode*)))
         (html *text-win*)
         (tag-col (TABLE-tag-col table))
         (x 0)
        )
    (set! x (assq col tag-col))
    (if x
         (set! x (cdr x))
         (begin
           (set! x (tk-name "tagcol" col))
           (funcall html 'tag 'configure x)
           (push (cons col x) tag-col)
           (set-TABLE  table :tag-col tag-col) 
         )
     )
  x
))

;;;   *text-win* should be original before do this 
(define (table-tag-clear table)
  (let* (  (mrow   (TABLE-maxrow table))
           (mcol   (TABLE-maxcol table))
         (j 0)
        )
    (while (<= j mrow)
       (funcall *text-win* 'tag 'remove (get-tag-row j) 'tablestart 'tableend)
       (inc j)
    )
   (set! j 0)
    (while (<= j mcol)
       (funcall *text-win* 'tag 'remove (get-tag-col j) 'tablestart 'tableend)
       (inc j)
    )
   (funcall *text-win* 'mark 'unset 'tablestart 'tableend)
))


;;;
(define (t-table p htm)  ;;; table start
  (let* ((b  (make-TABLE)) (tstack (HTMODE-table-stack *htmode*))
         (table 0) (win 0) (border (assoc "border" p))
         (new (gen-widget-name "tabl" ))
         (wins (HTMODE-text-win-stack *htmode*))
         (s 0)
         )
  ;;;(format #t "t-table property ~s  ~%" p)
   (set-TABLE b :border border)
  ;;;(tag-newline)
  (set! new (text new :wrap 'none :relief 'ridge))    ;;; :width 20 :height 5
  (init-tag-def new)
  ;;;(print-popup new)
  (tag-insert-win new 20 5)  ;;;; this w h will be changed after. So, don't care value here
  (push new wins) 
  (set! *text-win* new)
  (set-HTMODE *htmode* :table-stack (cons  b tstack) :text-win-stack wins)
  (funcall *text-win* 'mark 'set 'tablestart 'insert)
  (funcall *text-win* 'mark 'gravity 'tablestart 'left)  ;;; tablestart don't move
  (funcall *text-win* 'mark 'set 'tablerow 'insert)
  (funcall *text-win* 'mark 'gravity 'tablerow 'left)  ;;; tablerow don't move
 ;;; (format #t "table row  mark  set ~s~%"  (funcall *text-win* 'index 'tablerow))
  (push-tags  (list (get-tag-row 0) (get-tag-col 0)))
 ;;; (format #t "t-table end b ~s ~%" b)
   htm
))

;;; debug
(define (print-popup new)
 (let* ((s 0))
   (set! s (procedure-info (function new)))
   (set! s (cadddr s))  ;;;env
   (set! s (assq :bind s))
   (set! s (cdr s))
   (set! s (assoc (list "<Button-3>" 'popup) s))
   (format #t "init-tag-def win ~s bind  text ~s~%" new s)
))

(define (t-tr p htm)    ;;; table row
  (let* (( table (car  (HTMODE-table-stack *htmode*)))
         (row (TABLE-table-row table))
        )
   (inc row)
;;;    (format #t "t-tr  property ~%" p)
   (funcall *text-win* 'mark 'set 'insert 'end )
   (tag-newline)
   (funcall *text-win* 'mark 'unset 'tablerow )
   (funcall *text-win* 'mark 'set 'tablerow 'insert)   ;;; indicate row left corner
  (funcall *text-win* 'mark 'gravity 'tablerow 'left)  ;;; tablerow don't move
;;;  (format #t "table row  ~s  mark  set ~s~%" row  (funcall *text-win* 'index 'tablerow))
  (set-TABLE table :table-row row :table-col 0 :maxrow row)
  (pull-tag)
  (push-tag (get-tag-row row))
  (push-tag (get-tag-col 0))
 ;;; (format #t "t-tr end ~%" )
   htm
))

(define (t/tr)
  (pull-tag)
  (pull-tag)
)

(define (t/table)
  (let* ((tstack (HTMODE-table-stack *htmode*))
          (wins (HTMODE-text-win-stack *htmode*))
          (text-win (car wins))
          (s 0) (win  0)
          (c 0)
        )
  ;;;(format #t "t/table ~s ~s ~%" wins tstack)
  (tag-newline)

   (set! c (table-adjust text-win (pop tstack)))
  
  (pop wins)
  (set-HTMODE *htmode* :table-stack  tstack :text-win-stack wins)
  (set! *text-win* (car wins))
  (if (> (car c) 100) (tag-newline)) 
  (set-txtwin text-win (car c) (cdr c))
))


(define (t-td p htm)    ;;; table data
  (let* ((table (car  (HTMODE-table-stack *htmode*)))
         (col (TABLE-table-col table))
         (maxcol (TABLE-maxcol table))
         (pos 0)
         )
  ;;; (format #t "table-td ~s~%"  (car htm))
  ;;;; (label lab  :text (pop htm) :relief 'groove)
   (inc col)
  (if (> col maxcol) (set! maxcol col))
  (set-TABLE table  :table-col col :maxcol maxcol)
  (pull-tag)
  (push-tag (get-tag-col col))
  (funcall *text-win* 'mark 'unset 'tableinsert )
  ;;;(funcall *text-win* 'mark 'set 'insert  'tableinsert)

 ;;;; (format #t "t-td  col  ~s  row mark ~s~%" col  (funcall *text-win* 'index 'tablerow))
  (funcall *text-win* 'mark 'set 'insert  (list 'tablerow 'lineend))
  
  htm
))

(define t-th t-td)   ;;; table data  as header

(define (t-caption  p htm)    ;;; table  title
    htm
)

;;; left adjust
(define (table-adjust text-win  table)
  (let* ((maxcol (TABLE-maxcol table))
         (maxrow (TABLE-maxrow table)) 
         (border (TABLE-border table)) 
         (col 1)
         (box 0) (x 0)
         (left 0)(right 0)
         (w 0) (line 0) (lh 0)(rh 0) (lrh 0)
         (win 0)
         (pos-left 0)(pos-right 0)
         (left-max 0)(right-max 0)
         (height 0) (width 0) (win-size 0) (win-height ())(ww 0)
         (weights ())
        )
       (if border (set! border " | " ) (set! border "  "))
       (format #t "t/table  col ~s  row ~s  ~%" maxcol maxrow     )
    (while (<= col maxcol) 
       (set!  box  (funcall text-win 'tag 'ranges (get-tag-col col) ))
       ;;;(format #t "t/table  box ~s  ~%"  box   )
       ;;;(set! right (map cdr box))
       (set! win  (win-check table col))
       (when (or (pair? box) (pair? win))    ;;;  if col includes only widget that ha no tags!!
      ;;; (format #t "t/table  left  ~s   right ~s~%"  pos-left pos-right   )
      ;; (format #t "t/table  left-max  ~s  ~%"  left-max )
     ;;;  (format #t "t/table  right-max  ~s  ~%"  right-max )
        (set! x (get-lr-max box win  weights))
        (set! left-max (car x)) 
        (set! right-max (cdr x)) 
          (if (> right-max  width) (set! width right-max))
      ;;; (format #t "t/table   left-max ~s right-max  ~s  ~%" left-max  right-max )
         (while (or (pair? box) (pair? win))
            (set! x (get-line box win))
            (set! line (pop x))
            (if (> line height) (set! height line))
            (set! win-size (cadr x))
            (set! lrh (get-left-right (car x) win-size))
            (set! x (cddr x))
            (set! box (car x))
            (set! win (cadr x))
            (set! lh   (car lrh))
            (set! rh  (cdr lrh))
            (set! left lh)
            (set! right rh)
            (when win-size
               (set! x (cdr win-size))
               (set! ww (assq line weights))
               (if ww
                  (set-cdr! ww (+ (cdr ww) (car x) -1))
                  (push (cons line (- (car x) 1)) weights)
               )
              (set! w (assq line win-height))
               (if w
                   (set-cdr! w (max (- (cdr x) 1) (cdr w)))
                   (push (cons line (- (cdr x) 1)) win-height)
               )
             )
            (set! ww (assq line weights))
            (when ww
                 (set! w (cdr ww))
                 (set! left (+ w left))
                 (set! right (+ w right))
            )
         ;;;(format #t "t/table  pos-prev ~s  pos ~s ~%" pos-prev lh )
            (when (< left left-max)
              (funcall *text-win* 'mark 'set 'insert  (tk-string line #\. lh))
              (funcall *text-win* 'insert 'insert  (make-string (- left-max left) #\space))
              (inc rh (- left-max lh))
            )
           (funcall *text-win* 'mark 'set 'insert  (tk-string line #\. rh))
            (when  (< right right-max)
             (funcall *text-win* 'insert 'insert  (make-string (- right-max right) #\space))
            )
           (funcall *text-win* 'insert 'insert  border)  ;;;  border
         ;;; (if (> right width) (set! width rh))
        )
       )
      (inc col)
   )
   (inc height )
   (if (pair? win-height)
         (inc height (apply + (map cdr win-height)))
   )
   (inc width 4)
   (if (> width 130) (set! width 130))
   (funcall text-win 'configure :height height :width width)
 (cons width height)
)) 
                
(define (win-check table col)
  (let* ((wins (TABLE-win-stack table))
         (res ())
         (win 0) (x 0)
        )
   (while (pair? wins)
     (set! win (cdr (pop wins)))    ;;; new!
     (if (eq? col (TXTWIN-col win))
        (push (cons (TXTWIN-pos win) (cons (TXTWIN-width win) (TXTWIN-height win))) res)
     )
   )
  res
))    

(define (get-line box wins)
  (let* ((line #f)(res ()) (x 0) (rest ())  (wres ()) (wrest ()))
    ;;;(format #t "get-line ~s ~s~%" box wins)
    (when (pair? box)
      (set! x (car box))
      (set! x (car x))  ;;;line
      (set! line x)
      (map (lambda (z) (if (eq? (car z) line)  (push z res)  (push z rest) ))  box)
    )
    (when (not line)
      (set! x (car wins))
      (set! line (caar x))  ;;;line
    )
    (when (pair? wins)
      (map (lambda (z) (if (eq? (caar z) line)  (push z wres)  (push z wrest) ))  wins)
    )
  (set! wres  (get-size-win wres) )
;;;  (format #t "get-line end ~s  ~s ~s~%" line res wres)
   (list line res   wres  rest  wrest)
))

(define (get-size-win wres )
   (let* ((lh 100000) (rh -1) (x 0) (w 0) (width 0) (h 0)(height 0) (pos 0))
   (while (pair? wres)
     (set! x (pop wres))
     (set! pos (pop x))
     (set! w (car x))
     (inc width w)
     (set! h (cdr x))
     (if (> h height) (set! height h)) 
     (set! x (cdr pos))
     (if (< x lh) (set! lh x ))
     (set! x (+ x  1))   ;;;  win is 1 char
     (if (>  x rh) (set! rh x))
   )
  (inc width)   ;;;;  why????
  (if (> width 1)
        (cons (cons lh  rh) (cons width height))
        #f
  )
))
     

(define (get-left-right line-box win-size)          
  (let* ((pos 0)
         (x 0)  (lh 10000)(rh -1) 
         (h 1)
        ) 
       (when win-size
          (set! pos (car win-size))
          (set! lh (car pos))
          (set! rh (cdr pos))
       )
       (while (pair? line-box)
            (set! x  (cdr (pop line-box) ))
            (if (< x lh)(set! lh x))  
            (if (> x rh)(set! rh x))  
       )
   (if (>= rh 0)
      (cons lh rh)
      #f
   )
))

(define (get-lr-max box col-win weights)
  (let* ((pos 0)
         (x 0)  (lh 0)(rh 0) (win-size 0)
         (lrh 0) (lef 0)(right 0) (line 0)
         (wmax 0) (w 0)
        )
     (while (or (pair? box) (pair? col-win))
       (set! x (get-line box col-win))
       (set! line (pop x))
       (set! win-size (cadr x))
       (set! lrh (get-left-right  (car x) win-size))
       (set! x (cddr x))
       (set! box (car x))
       (set! col-win (cadr x))
       (set! lef (car lrh))
       (set! right (cdr lrh))
       (set! x (assq line weights))
       (when  x 
            (set! x (cdr x))
            (set! lef (+ x lef) )
            (set! right (+  x  right) )
       )
;;;;  (format #t "get-lr-max  lef right  ~s ~s~%" lef right)
       (when win-size
          (set! x (cadr win-size))
          (inc right x)
       )
       (set! w (-  right lef))
       (if (> w wmax) (set! wmax w))
       (if (> lef lh) (set!  lh lef))
       (if (> right rh) (set!  rh right))
     )
   (set! rh (+ lh wmax))
   (cons lh rh) 
))    
          
          

