;;;  <form>
;;;
(in-package "http")
(define *formnum* 0)

(define (winvariable name)
   (tk-name (tk-string name *formnum*))
)

(define (t-form p htm)    ;;;
  (let* ((x 0)(s 0) (url "") (prop p) (form (make-FORM)) )
    (inc *formnum*)
    (set-HTMODE *htmode* :form form)
    ;;;  defult is "GET" for google
    (set-FORM form :action (get-abs-url (get-prop p 'action ""))
            :method  (get-prop p 'method "GET")   
            :name (get-prop p 'name #f)    ;;;  don't need???
    )  
  htm
))

(define (t/form)
    (set-HTMODE *htmode* :form #f)
)

(define (t-input p htm)    ;;;
  (let* ((x 0)(s 0) (dest 0) (prop p)  (data ()) (alt 0)
         (type 0)(name "hoge") (size 1) (ent 0)(value "1")(check #f) 
         (winvar 0)
         (form  (HTMODE-form *htmode* ))
        )
    (set! type (get-prop p 'type "text")) 
    (set! alt  (get-prop p 'alt  "submit")) 
    (set! name  (get-prop p 'name  "hoge")) 
    (set! value  (get-prop p 'value  #f)) 
    (set! check  (get-prop p 'checked  #f)) 
    (set! size  (get-prop p 'size  1))
    (if (string? size) (set! size (string->number size))) 
    (if  (string-ci=? type "hidden")
       (set! winvar value)
       ;;; (list name value)   ;;; mada   hidden entry  , used for submit only
      (begin
  ;;;   (format #t "type ~s~%" type)
        (set! ent (gen-widget-name name))
        (cond ((string-ci=? type "submit")
                  ;;;    (when (eq? (string-ref value 0) #\-))   Don't care this case
                  ;;;       ss send  care this case OK
                   (if (not value) (set! value "submit"))
                   (set! size (string-byte-length value))
                   (make-submit ent name value form)
                   (set! name #f)
                   )
              ((string-ci=? type "reset")    ;;;;  mada
                   (if (not value) (set! value "Reset"))
                   (set! size (string-byte-length value))
                   (make-reset  ent  value form)
                   (set! name #f)
                   )
             ((string-ci=? type "image")   ;;; image button    mada!
                   (if (not value) (set! value "submit-IMG"))
                   (set! size (string-byte-length value))
                   (make-submit ent name value form)
                   (set! name #f)
                   )

              ((string-ci=? type "radio")
                  (set! winvar (winvariable name))
                   (radiobutton ent :variable winvar :text "" :value value)
                   (if check (funcall ent 'select)) 
              )
              ((string-ci=? type "checkbox")
    ;;; (format #t "variable checkbox ~s  ~s~%" name value)
                  (set! winvar (winvariable name))
                   (checkbutton ent :variable  winvar :text "" :onvalue value
                         :offvalue #f)  ;;;  this cause trouble only or value="0"
                   (if check (funcall ent 'select))
                )
              (else
                  (if (eq? size 1) (set! size 10))
                  (set! winvar (winvariable name))
                  (if (string-ci=? type "password")
                    (entry ent :textvariable winvar  :width size :show "*")
                    (entry ent :textvariable winvar  :width size)
                  )
                  (when value
                     (symbol-value-set winvar value)
                     (push-form-reset (lambda() (symbol-value-set winvar value))
                              form)
                 )
              )
        )
        (tag-insert-win ent size 1 ) ;;; new!!!
        ;;;;(set! value #f)
      )
    )
   (if name
       (push-form-result name winvar form)
   )
  htm
))

(define (push-form-result name value form)
  (let* ((res (FORM-result form)))
    (when (not (assoc name res))
       (push (cons name value) res)
       (set-FORM form :result res)
    )
   res
))

(define (push-form-reset cmd form)
  (let* ((reset  (FORM-reset form)))
       (set-FORM form :reset   (cons cmd reset))
))

(define (make-submit wname name value form)
    (button  wname   :text value :command
                  (lambda () (form-submit  name value form) ) )
)

(define (make-reset wname  value form)
    (button  wname   :text value :command
                  (lambda () (map (lambda(x) (x))  (FORM-reset form)))  )
)

(define (make-image wname name value form)
    (button  wname   :text value :command
                  (lambda () (form-submit  name value form) ) )
)

(define (form-submit  sub-name sub-value form)
  (let* ((x 0)(s 0)(v 0)(method 0)(url 0)(name 0)(name-str 0)(value 0) (res ())
        )
     (set! url (FORM-action form) )
     (set! method (FORM-method form))
     (set! x (FORM-result form))
     (while  (pair? x)
        (set! s (pop x))
        (set! name (car s))
          (set! v (cdr s))
          (cond ((string? v)  )
                ((symbol? v)
                  (set! v  (symbol-value v))  ;;; may be #f
                  )
                ( (procedure? v)  (set! v (v)))
                (else (set! v #f) )
          )
           (if (string? v)
                   (push (cons name (kanji->sjis v)) res)
           )
     )
     (push (cons sub-name (kanji->sjis sub-value)) res)
     (if *debug* (format #t "submit: method ~s msg  ~s~%" method res))
    (if (string-ci=? method "GET")
       (http-cgi-get url res)
       (http-cgi-post url res)
   )
))


(define (t-textarea p htm)    ;;;
  (let* ((x 0)(s 0) (dest 0) (prop p) (out "")
         (type 0)
          (name (get-prop p 'name "hoge")) 
          (rows(get-prop p 'rows 8))
          (cols (get-prop p 'cols 30))
          ( ent (gen-widget-name name))
          (form (HTMODE-form *htmode*))
          ( cmd 0)
        )
    (text  ent  :height rows :width cols)
    (tag-insert-win ent cols rows )    ;;;New!!!
    (set! dest #t)
    (while (and (pair? htm) dest)
       (set! x (pop htm))
       (set! s (check-tag-end htm 't/textarea))
       (set! dest (not s))
       (if s
          (begin
            (set! dest #f)
            (set! htm s)
          )
         (begin
           (set! x (pop htm))
           (when (or (string? x) (eq? x #\newline))
               (funcall ent 'insert 'insert x)
               (set! out (tk-string out x))
           )
         )
       )
    )
  (when form
     (set! cmd (lambda()(funcall ent 'get "1.0" 'end)))
     (push-form-result name cmd form)
   ;;;  (format #t "textarea reset ~s~%" (FORM-reset form))
     (if (not (equal? out ""))
         (push-form-reset (lambda()(funcall ent 'delete "1.0" 'end)
                  (funcall ent 'insert 'insert out)) form)
     )
  )
  htm
))

(define (t-select p htm)    ;;;pull down menu -> listbox
  (let* ((x 0)(s 0) (dest 0) (opt 0) (prop p) 
         (type 0)(name 0)(ent 0) (size 0) (box #f) (cmd 0)
         (form (HTMODE-form *htmode*))  (leng 0)
        )
    (set! name (get-prop p 'name "hoge"))
    (set! size (get-prop p 'size 1))
    (if (string? size) (set! size (string->number size)))
    (set! box (assq 'multiple p))
    (set! opt (get-option-list p htm))
    (when opt
       (set! htm (car opt))
       (set! opt (cdr opt))
       (set! leng (length opt))
       (set! ent (gen-widget-name name))
       (set! s (make-select-win ent name opt))
       (tag-insert-win ent (car s)(cdr s))  ;;; New!!!
       (when form
         (set! cmd 
            (lambda() (let* ((ind (funcall ent 'curselection)))
                (if (and (number? ind) (< ind leng)) ;;; may be ()
                    (car(list-ref opt ind))
                    #f
                )
            ))    
         )
         (push-form-result  name cmd form)
       )
    )
  htm
))

(define (make-select-win win var opt)
 (let* ((memo opt) (h 0)(w 0)(n 0) (x 0))
   (set! h  (length opt))
   (listbox win :height h )
  (while (pair? opt)
     (set! x  (cdr (pop opt)))
     (set! n (string-byte-length x))
     (if (> n w) (set! w n))
     (funcall win 'insert 'end x)
  )
 (funcall win 'configure :width w)
 ;;;(format #t "listbox ~s ~s~%" h w)
 (cons w h)
))

(define (get-option-list p  htm)   ;;;; for select
  (let* ((x 0)(s 0) (cont #t) (dest 0) (prop p) (name 0)
         (type 0)(err #f)(name 0)(value #f) (dsp 0)(res ()))
    (while (and cont (pair? htm))
       ;;;(set! x (pop htm))
       (set! cont (check-tag htm  't-option))
       (if  cont
            (begin (set! htm (car cont))(set! p (cdr cont)))
            (set! cont #f)
       )
       (when cont
          (set! prop  p)
          (set! value (assoc "value" prop))
          (if value  (set! value (cdr value)))
          (set! dsp (get-string-html htm))
           (set! htm (car dsp))
           (set! dsp (cdr dsp))
           (if (not value) (set! value dsp))
          (push (cons value dsp) res)
          (set! s (check-tag-end htm  't/option))
          (if  s  (set! htm s))
       )
       (set! x (check-tag-end  htm 't/select))
        (if x
            (begin (set! cont #f) (set! htm x))
             (if (not cont) (set! err #t))
        )
   )
  ;;;;(format #t "get-option-list ~s ~s ~%" err res)
  (if err  #f (cons htm (reverse res)))
))

