;;;;  http-base.ss
;;;;   2005.1.22  separated from http.ss
;;;;   basic functions for http
;;;;
(in-package "http")

(define *User-Agent* "User-Agent: Mozilla/4.0 [en] (compatible; MSIE6.0; Win32)")
;;;
;;;;(define *screen* #f)   ;;; display  screen
(define *orgmsg*  #f)   ;;; for debug

;;; (define *User-Agent* "User-Agent: ss/1.94")
(define *Proxy* #f)
(define *Proxy-list* ()) 
(define *Address-base* "")
(define *URL* "")    ;;; for popuponly

;;;  euc or utf8
(define *kanji-mode* (kanji-mode))
(if (not *kanji-mode* )(set! *kanji-mode* :euc))
(define kanji->sjis  
    (if (eq? *kanji-mode* :euc) euc->sjis  utf8->sjis))

;;;
(defstruct URL (:url "")(:proto "file")(:host #f)(:location #f) (:referer #f) (:cgi #f)
         (:ishtml #f)
         (:base "") (:port "http") (:object #f) (:binary #f) (:request ""))

(defstruct Header  (:status -1)
     (:content-type "text/plain") (:content-length 0) (:last-modified #f)
     (:encoding #f) (:mime-version #f)  )

(defstruct Comm  (:soc #f) (:net #f) ( :out #f))

(defstruct (DLD :include URL :include Header :include Comm)
         :method :post  :orgmsg
         (:screen *active-web*)    ;;;;  display screen infomation requested 
          :dlnum (:dlstate 'URL) (:proxy *Proxy*))
;;;  ssweb
(defstruct SWEB :www :header :html :url :status :popup (:popupfunc ())
                 :urlvar ( :url-his ()) )
;;;;  http-engine
(defstruct TABLE  (:maxrow 0) (:maxcol 0) (:table-row 0)(:table-col 0)
                  (:tag-row ()) (:tag-col ()) (:border #f) 
                  (:win-stack ()) )
;;;  text-win-stack is for recover *text-win*
(defstruct HTMODE (:text-win-stack (cons (get-text-win) ()))
         (:pre  #f)( :list  #f)(:linum 0)  (:href #f) (:form #f)
        (:table-stack ()) )
(defstruct FORM (:result ()) (:reset ())  (:action #f) (:method #f) (:name #f) )
;;;;;(defstruct INPUT :type  :variable :name :value  :winname ( :winvariable #f))

;;;  embedded widget in html
(defstruct TXTWIN  (:width 0) (:height 0) (:row 0)(:col 0) (:pos 0))


;;;;  DLD
(define (request-DLD url method cgi post)
   (let* ((dld (make-DLD)) (surl (url-decompose url cgi)))
     (subst-structure surl dld)
     ;;;(set-DLD dld :method method :cgi cgi :post post)
     (set-DLD dld :method method :post post)
     dld
))
;;;;
;;;;   decompose url to port host local
;;;;     url is of the form   http://......:number
;;;;     url is of the form   http://......:number/.../.../index.html
;;;;     url is of the form   http://....../.../.../index.html:number

;;;;(define R-port (regexp->nfa #":\d++"))
(define R-host (regexp->nfa #"[^/:]++"))
(define R-url  (regexp->nfa 
         #"(?x)(?<proto>\w++)://(?<host>(??{R-host}))       # proto://host
                 (?(?=:):(?<port>\d++))                    #  :number
                 (?<loc>[^\s\n]*+)                               # loc=rest
          " ))

(define R-base  (regexp->nfa  
           #"(?x)(?<base>/([^/]++/)*+)                         # /../.../
             (?(?!$)
                (?(?!:)
                  (?<obj>[^:.]+(?(?=\.)\.(?<ext>[^.:]*)))     # *[.*]
                )
                (?(?=:)
                     :(?<port>\d++)
               )
             )
            " ))

(define (url-decompose url . cgi)
  (let* ((ind 0) (pro 0)(ans 0) (surl (make-URL)))
   ;;;;(set! url (regexp url #"\S+"))
   (set! ans (regexp url R-url))
   (if (not ans)
           (set! url (regexp url #"\S+"))
           (set! url ans)
   )
   (set-URL  surl :url url :referer url)  ;;;; Referer= url
   (when ans
      (set! pro  (match-string 'proto))
      (when  pro
          (set! pro  (string-downcase pro))
          (set-URL surl :proto pro)
          (url-decompose-proto pro (match-string 'host)
                  (match-string 'port) (match-string 'loc) surl )
     )
  )
  (if (and (pair? cgi) (car cgi)) 
      (set-URL surl :cgi #t :object #f :ishtml #t :binary #f)
  )
   (format #t "url-decompse surl ~s~%" surl)
  surl
  
))

(define (url-decompose-proto  proto host port loc surl)
   (let* ((x 0)(y 0)(obj #f)(base 0) (ishtml #t) (ext #f))
     (if (not loc)  (set! loc "/") )
     (set! x (regexp loc R-base))
     (if (not port)
         (set! port (match-string 'port))
     )
     (if port
         (set! port (string->number port))
          (set! port proto)
     )
     (set! base (match-string 'base))
     (set! obj  (match-string 'obj))
     (set! ext (match-string 'ext)) 

    (set-URL surl  :port port :host host :location  loc)
    (if (number? port) (set! host (tk-string host ":" port)))
    (set-URL surl :base (tk-string proto "://" host base))
    (when  ext
            (set! ishtml (or (string-ci=? ext "htm")(string-ci=? ext "html")))
     ) 
    (set-URL surl :object obj :ishtml ishtml :binary (not ishtml))
      ;;;;  ishtml may be change in http-proto.  binary is set for original request
      ;;;;     is binary.
  surl
))

(define (url-html? url)
   (let* ((x 0)(proto 0)(host 0) (loc 0)(obj #f))
     (set! x (regexp url R-url))
    (if x
       (begin
          (set! proto (match-string 'proto))
          (if (and proto (string-ci=? proto "http"))
            (begin
              (set! loc  (match-string 'loc) )
              (if loc
                (begin
                   (set! x (regexp loc R-base)) 
                   (set! obj (match-string 'obj))
                   (if obj
                        (regexp obj #"\.html?$" :nocase)
                        #t
                    )
                )
                #t
              )
             )
            #f
          )
       )
      #f
    )
))

(define (get-abs-url x . base)
    (if (string-index "http://" x)
          x
      (begin
         (if (eq? base ()) (set! base *Address-base*) (set! base (car base)))
         (set! base  (get-abs-url-aux x base))
         (if base  base x)  ;;;  return original if fail!
      )
    )
)


(define (get-abs-url-aux x base)
    (cond ((eq? base #f) #f)
          ( (equal? (string-index "/" x) 0)
                (set! x (substring x 1 :end))
                (string-append base x)
              )
          ( (equal? (string-index "./" x) 0)
                (set! x (substring x 2 :end))
                (string-append base x)
              )

          ( (equal? (string-index "../" x) 0)
                 (set! x (substring x 3 :end))
                 (get-abs-url-aux x (regexp (substring base 0 :end -1) #".*/"))
              )
          (else
             (string-append base x) )
     )
)

;;;;
(define (url-encode str)
  (let* ((lis (string->list str)) (res ()) (x 0))
     (while (pair? lis)
        (set! x (url-encode-char  (pop lis)))
        (if (char? x)
              (push x res)
              (while (pair? x)
                  (push (pop x) res))
        )
     )
   (list->string (reverse res))
))

(define (url-encode-char x)
    (cond ((char-alphabetic? x) x)
          ((char-numeric? x) x)
          ((eq? x #\*) x)
          ((eq? x #\-) x)
          ((eq? x #\.) x)
          ((eq? x #\@) x)
          ((eq? x #\_) x)
          ((eq? x #\space) #\+)
          (else
             (set! x (char->integer x))
             (if (> x 255)
                   (append (int->url-hex (ash x -8)) (int->url-hex (logand x 255)))
                   (int->url-hex x)
             )
         )
   )
)

(define (int->url-hex x)  ;;; 0<=x<=255   ->   % 3 f
   (cons  #\%  (string->list (format #f "~2,'0x" x)))
)

;;;;
(define (to-utf8-file  file)
  (let* ((tmp (make-temp-file)) )
   ;;;(system  (tk-string "nkf -e " file ">" tmp ))
   (kconv-file file tmp *kanji-mode*)
  (remove-file file)
  tmp
))

(define (trans-msg-file  file dld)
  (let* ((res ()) (in 0) (x 0))
   (if dld
       (begin
         (set! x (DLD-screen dld))
         (if x (set! *active-web* x))
         (set! *Address-base* (DLD-base dld))
       )
        (set! *Address-base* "")
   )
   (set! file (to-utf8-file file))
   ;;;(format #t "~%file ~s~%" file)
   (set! in (open-input-file file))
   (set! x (read-line in))
   (while (not (eof-object? x))
     (push x res)
    ;;; (set! x (insert-html  x ))
     (set! x (read-line in))
   )
   (close-port in)
  (remove-file file)
  (set! *recv* (reverse res))
  (html-recv *recv* dld)
  (tag-html *recv*)
  *recv*
))

(define (trans-msg-str  str dld)
  (let* ((res ()) (in 0) (x 0))
   (set! *orgmsg* str)   ;;; for debug only
   (if dld
       (begin
         (set-DLD dld :orgmsg str)
         (set! x (DLD-screen dld))
         (if x (set! *active-web* x))
         (set! *Address-base* (DLD-base dld))
       )
        (set! *Address-base* "")
   )
   (set! str (kconv str *kanji-mode*))
   ;;;(format #t "~%file ~s~%" file)
   (set! in (open-input-str str))
   (set! x (read-line in))
   (while (not (eof-object? x))
     (push x res)
    ;;; (set! x (insert-html  x ))
     (set! x (read-line in))
   )
   (close-port in)
  (set! *recv* (reverse res))
  (html-recv *recv* dld)
  (tag-html *recv*)
  *recv*
))

;;;
(define (href . regpat)
  (append (apply href-abs regpat) (apply href-relative regpat))
)

(define (href-abs  . regpat)
   (set! regpat   (if (pair? regpat) (car regpat) #f))
   (href-aux *href-abs* regpat)
)

(define (href-relative  . regpat)
   (set! regpat   (if (pair? regpat) (car regpat) #f))
   (href-aux *href-relative* regpat)
)

(define (href-google)
  (let* ((y 0))
    (set! y (map (lambda(x) (if (regexp x #"\?") #f x)) (href-abs)))
    (reverse (remove #f y))
))


(define (href-aux lis pat)
   (if pat
     (begin
        (set! pat (regexp->nfa pat))
        (do ((res ()) (x 0))
          ((null? lis) res)
          (set! x (pop lis))
          (if (regexp x pat) (push x res))
       )
     )
     lis
  )
)
;;;;

