;;;  ke control functions
;;;  04.5.31
;;;;
(define *input-controls* ())

(define (make-control cmds . seq)
   (let* ((c 0) (cont *input-controls*))
      (set! c (assq (car seq) cont))
      (when (not c)
          (set! c (cons (car seq) ()))
          (push c  *input-controls*)
      )
      (make-control-data cmds (cdr seq) c)
))

(define (make-control-data cmds seq c)
   (if (null? seq)
       (set-cdr! c cmds)
       (let* ((x 0))
           (set! x (assq (car seq) (cdr c)))
           (when (not x)
              (set! x (cons (car seq) ()))
              (set-cdr! c (cons x (cdr c)))
           )
          (make-control-data cmds (cdr seq) x)
       )
  )
)

(define (CTRL c)
  (integer->char (- (char->integer c) 64))
)


(define (inkey-esc)
   (let* ((x 0)(n 0))
       (set! x (inkey #f))
       (set! n (char->integer x))
       (if (or (< n 32) (= n 127))
             (if (eq? x #\newline)
                 x
                (get-control x *input-controls*)
             )
             x
       )
))

(define (get-control x  data)
  (let* ((data (assq x data)))
    (while (pair? data)
        (set! data (cdr data))
        (when (pair? data)
           (set! x (inkey #f))
           (set! data (assq x data))
         )
    )
   data
))

#|
(define (test)
  (let* ((c 0))
     (while c
        (set! c (esc-key))
        (format #t "~s~%" c)
     )
))
|#
           
