;;;;  R-nfa.ss
;;;;  make nfa
;;;;

(in-package "regexp")

(define *nfa-state* ())
(define *nfa-trans* ())

(define  (nfa exp)
   (set! *nfa-state* ())
   (set! *nfa-trans* ())
   (R-reduce exp)
   (nfa->ext (make-nfa))
)

(define (regexp->nfa exp)   ;;;  exp is by R-read 
  (let* ((v 0))
   (if (string? exp) (set! exp (make-regexp exp)))
   (set! v (cdr exp))
   (if (vector? v) 
      exp
      (cons   (car exp) (nfa v))
  )
))
                                                                                                     
(define (get-trans-rec E)
   (let* ((trans (assq E *state-trans*)))
       (if trans
         (begin
           (set! trans (cdr trans))
           (cond ( (number? trans)
                      (get-trans-rec trans))
                 ((and (pair? trans) (number? (car trans)))
                    (if (eq? (cdr trans) 0)   ;;; (n . 0)->n
                         (begin   ;;;;  exists (7 7.0)
                           (if (eq? E (car trans))
                               (set! *state-trans* (remove (cons E trans) *state-trans*))
                           )
                           (get-trans-rec (car trans))  
                         )
                            trans
                    )
                  )
                 (else
                     trans)
           )
        )
       #f
     )
))
                                                                                                     
(define (make-nfa)
  (let* ((k *state-num*) (v (make-vector (if (= k 1) 2 k) 0)))
    ;;;;(vector-set! v 0 0)  ;;;;  epsilon-state
    (do ((i 1(+ i 1))(x 0))
        ((= i *state-num*))
        (set! x (get-trans-rec i))
        (if x (vector-set! v i x))
    )
   v
))
                                                                                                     
#|                                                                                                     
(define (nfa->ext v)
  (let* ((nfa (vector-ref v 1)))
     (while (number? nfa)
       (set! nfa (vector-ref v nfa))
     )
    (if  (symbol? (car nfa) )
         (begin
            (vector-set! v 1 nfa)
            v
         )
        (begin
          (extend-state nfa 1 )
          (make-nfa)
        )
    )
))
|#

(define (push-trans E trans)
  (if (member E *nfa-state*)
     #f
    (begin
       (push E *nfa-state*)
       (push (cons E trans) *nfa-trans*)
      E
   )
  )
)

(define (nfa->ext v)
  (let* ((nfa (vector-ref v 1)))
      (extend-state nfa 1 v)
      (reduce-state)
      (set! *state-num*  (+ (apply max *nfa-state*) 1))
      (set! *state-trans* *nfa-trans*)
      (make-nfa)
))
                                                                                                     
(define (extend-state  nfa state v)
 (let* ((x 0)(y 0)(c 0))
       (set! c  (push-trans  state  nfa) )
   (when (and c (pair? nfa))
      (set! x (car nfa))
      (set! y (cdr nfa))
      (cond ((number? x)
               (extend-state  (vector-ref v x) x v)
               (extend-state  (vector-ref v y) y v)
              )
           ((symbol? x))
           ((pair? x)
               (set! y (car x))
               (cond ((eq? y :or)   ;;; ((:or ...))
                          (set! c (cadr x))
                         (extend-state (vector-ref v  c)   c  v)
                          (set! c (caddr x))
                         (extend-state (vector-ref v  c)   c  v)
                        )
                     ((or (eq? y :not ) (eq? y :forward));;;(eq? y :try))  ;;; New!!!
                        (extend-state (vector-ref v (cadr x)) (cadr  x)  v)
                       )
                     ((eq? y :if)
                          (set! x (cdr x))
                         (set! c (pop x)) 
                         (if (and (pair? c) (eq? (car c) :test))
               ;;;;(or (eq? (car c) :test)   (eq? (car c) :try)))
                              (extend-state (vector-ref v (cadr c)) (cadr  c)  v)
                          )
                         (set! c  (pop x))
                         (extend-state (vector-ref v  c)   c  v)
                         (if (pair? x)
                             (extend-state (vector-ref v (car x)) (car  x)  v)
                         )
                      )
                     (else   ;;;??? error?
                        (error 666 nfa)
                        )
                )
              )
            (else  (error 666 nfa))
    )
  )
))

(define (change-trans  nfa  v)
 (let* ((x 0)(y 0)(c 0)(d 0)(e 0))
   (when  (pair? nfa)
      (set! x (car nfa))
      (set! y (cdr nfa))
     (set! nfa
       (cond ((number? x)
               (cons  (vector-ref v x) 
                        (vector-ref v y) )
              )
           ((symbol? x) nfa)
           ( (eq? x :test)
              ;;;;(or (eq? x :test)  (eq? x :try))  ;;; for nfa=(:test n)
                (set! c (car y))
                (set! c  (vector-ref v  c))
                (list x c )
            )
           ((pair? x)
               (set! y (car x))
               (cond ((eq? y :or)   ;;; ((:or ...))
                          (set! c (cadr x))
                         (set! c  (vector-ref v  c))
                          (set! d (caddr x))
                         (set! d  (vector-ref v  d))
                         (list (list :or c d))
                        )
                     ((or (eq? y :not ) (eq? y :forward))
                                   ;;; (eq? y :try))  ;;;New
                          (set! c (cadr x))
                         (set! c  (vector-ref v  c))
                         (list (list y c ))
                       )
                     ((eq? y :if)
                          (set! x (cdr x))
                         (set! c (pop x))
                         (set! c (change-trans c v))
                         (set! d  (pop x))
                         (set! d (vector-ref v  d) )
                         (if (pair? x)
                            (begin
                              (set! e  (vector-ref v (car x)))
                              (list (list :if c d e))
                            )
                            (list (list :if c d ))
                         )
                      )
                     (else   ;;;??? error?
                        (error 663 nfa)
                        )
                )
              )
            (else  nfa)
       )
     )
  )
  nfa
))


(define (reduce-trans cv)
   (let* ((res ()) (x 0)(E 0))
     (while (pair? *nfa-trans*)
        (set! x (pop *nfa-trans*))
        (set! E (pop x))
        (set! E (vector-ref cv E))
        (push (cons E (change-trans x cv)) res)
     )
     (set! *nfa-trans* res)
))

(define (reduce-state)
   (let* ((x 0)(s *nfa-state*)
           (num (+ (apply max s) 1)) (cv (make-vector num #f)))
       (sort s <)
       (set! *nfa-state* ())
       (vector-set! cv 0 0)
       (if (eq? (car s) 0) (pop s))
       (do ((i 1 (+ i 1)))
           ((null? s))
           (set! x (pop s))
           (vector-set! cv x i)
           (push i *nfa-state*)
       )
      (reduce-trans cv)
))
                                                                                                          

