;;; usage:  (get-file-name)
;;;         (get-file-name "*.sgf")
;;;         (get-file-name "*.scm" "*.stk" "*.lsp")
;;;  if no-file then #f
;;;  if no selection,   ""  is returned
;;;      2002.5.20  
;;;     2002.8.20    chdir version start
;;;
;;(load "init")
(in-package "get-file")

(define *file-kakutei* "")
(define *dir-list* ())
(define *dir-listing* ())
(define *file-ext* "")

(define (get-file-name . ext)
  (let ((n-files 0) )
    (toplevel '.dir)
     (set!  *file-kakutei* "")
    (if (null? ext) 
         (set! ext '("*") ) )
    (set! *file-ext* ext)
    (wm 'title  .dir  "File Select window")
    (wm 'geometry .dir "500x430+80+80")
     (label '.dir.labwdir :text (getcwd))
     (grid .dir.labwdir :column 2)
     (listbox  '.dir.wdir  
        :yscrollcommand
                  (lambda l (apply  .dir.wdir_yscroll 'set l))
       :width 20 :height 16)
     (scrollbar  '.dir.wdir_yscroll  :orient 'vertical
                 :command
                    (lambda l (apply  .dir.wdir  'yview l))
       )
      (listbox  '.dir.lb 
        :yscrollcommand
                  (lambda l (apply  .dir.yscroll 'set l))
       :width 35 :height 16)
     (scrollbar  '.dir.yscroll  :orient 'vertical
                 :command
                    (lambda l (apply  .dir.lb  'yview l))
       )
     (grid  .dir.wdir .dir.wdir_yscroll
           .dir.lb   .dir.yscroll :row 2  :sticky 'nws)
     (label '.dir.name :text "file name" :bg 'snow :width 25  :height 2)
     (grid .dir.name :column 2 :sticky 'ew)
     (button '.dir.ok :text "OK" :command '(destroy .dir))
     (button '.dir.cancel :text "CANCEL" :command 
                        '(begin (set! *file-kakutei* "")(destroy .dir))  )
     (grid .dir.ok  :column 2 :sticky 'ew ) 
     (grid  .dir.cancel :column 2 :sticky 'e )   ;;;  :sticky 'ew )
      (set! n-files (dir-reset))
     (if (= n-files 0)
       (begin
         (.dir.name 'configure :text "No files")
         ;   (after 2000)
         ;(destroy .dir)
         #f
        )
     )
     
    (bind '.dir.lb   "<Button-1>" (lambda (y)
                          (get-file-ypos  y )
                          )
          )
    (bind '.dir.wdir  "<Button-1>" (lambda (y)
                          (chd-ypos  y )
                          )
          )
    (bind  '.dir "<Return>" (lambda () (destroy .dir)))
     (tkwait 'window .dir )
         *file-kakutei*
))
(define (dir-reset)
   (let ((n-files 0))
   (.dir.lb 'delete 0 'end)
   (.dir.wdir 'delete 0 'end)
     (set!  *dir-list* (sort (apply glob-file  *file-ext* ) string<?))
      ;;;  up dir
      ;;;(.dir.lb 'insert 'end "..")
      (set! *dir-listing* (sort (glob-dir-dot) string<?))
      (do ((x ()) (i 0) (dirs *dir-listing*))
          ((null? dirs) )
         (set! x (pop dirs))
          (.dir.wdir 'insert 'end  x)
          ; (format #t "~a~%" x)
          (set! i (+ i 1))
       )
     (do ((x ()) (i 0) (dirs *dir-list*))
          ((null? dirs) (set! n-files i))
         (set! x (pop dirs))
          (.dir.lb 'insert 'end  x)
          ; (format #t "~a~%" x)
          (set! i (+ i 1))
        )
    n-files
))
(define (get-file-ypos  y )
   (let ((i  (.dir.lb  'nearest y  ))
           (file "")
            )
     ; (format #t "~s ~s ~%" i y)
         (set! file  (list-ref *dir-list*  i ))
     (.dir.name 'configure :text file)
     (set! *file-kakutei* file)
)) 
(define (chd-ypos  y )
   (let ((i  (.dir.wdir  'nearest y  ))
           (file "")
            )
     ; (format #t "~s ~s ~%" i y)
         (set! file  (list-ref *dir-listing*  i ))
     (chdir file)
     (.dir.labwdir 'configure :text (getcwd))
     
     (dir-reset)
))
 
(define (glob-dir-dot)
   (let ((s (glob-dir  "*")))
        (cons ".." (cons "." s))
))

(export 'get-file-name)
(use-package "get-file" "ss")

;;(get-file-name)



