;;;  ssh auth check
;;;

(define (auth host)
   (let* ((f (make-temp-file))(out (open-output-file f)) (in 0) (s 0))
     (display "pwd" out)
     (close-port out)
     (set! s (exec (tk-string "sftp -b " f " " host)))
     (remove-file f)
     (if (string-index  "directory" s)
          #t
          #f
     )
))

(define (check-agent)
  (let* ((s (exec "ssh-add -l")))
    (if (string-index "no iden" s)
       (begin
         (format #t "~a~%" s)
         (help-ssh)
          #f
       )
       (begin
          (set! s (string-split s))
          (set! s (list-ref s 2))
          (set! s (tk-string s ".pub"))
         (format #t "~a~%" s)
         (if (file-exists? s)
             s
             #f
         )
       )
     )
))

(define  pub-key (check-agent) )
#|
(when pub-key        
   (auth "umail")
)
|#
(define (send-pub-key host)
   (let* ((cmd
     (tk-string "cat " pub-key "|ssh " host " \""
       "cat >>~/.ssh/authorized_keys; chmod 600 ~/.ssh/authorized_keys"
       #\")))
    (format #t "Try the following:~%~%")
    (format #t "~a~%" cmd)
    (newline)
))

(define (main)
 (let* ((h 0))
   (format #t "host name? ")
   (flush)
    (set! h (read-line))
    (if (auth h)
       (format #t "host auth is good!~% ")
      (when pub-key        
        (send-pub-key h)
      )
    )
))

(main)
 

