;;;;  temp-trans.ss
;;;; 2004.3.25
;;;; 4.3
;;;;    template transform  only
;;;;       if symbol S is not macro,literal,pat, then S is transformed
;;;;;      (template S alias env-assoc (global-value . macro-def))
;;;;  2005.10.16 revised
;;;;       
#|
  trans defitiniton:
  1. symbol 
       macro   => (macro key)
       literal -> (literal word ass)
                   ass is (assoc word env)
       pat variable -> (pat var)
  2. contnats
      (), keyword,string,etc.   No change
  3. (P ...   .  Q)
       ->   ((...  (trans P)) .  (trans Q)) 
  4. (P . Q)
       -> ((trans P)  . (trans Q))
  5. #(P1 ...... Pn)
     ->(vector #f (trans P1) .....)
  6. #(P1 ...... Pn ...)
     ->(vector #t (trans P1) .....  (... (trans Pn)))

   (trans P)  will be a pair or not pair(constants).
|#

 (define (template-trans p env)
     (set! *dot-mark* '(S-write-dot))
     (set! *symbol-trans-func* template-symbol-trans)
     (set! *alias-data* ())
     (exp->outlinear  (pat-trans-common p env))
)


(define (template-symbol-trans p env)
   (cond ((eq? p *macro-key*) (list 'macro p))
         ((memq p *literal*) (list 'literal p ))
         ((memq p *pat-variable*) (list 'pat p *pat-level* ))  ;;; New!!!
         (else
           (let* ((local (assq p env))(res (get-macro p )) (def 0)(flag 0))
             (cond (local
                       ;;;(list 'local  p (gen-alias p) local))
                       ;;; alias must have same value
                      (set! res (gen-alias p))
                       (symbol-value-set res (cdr local)) 
                       (list 'local  p res local))
                   ((special? p)
                          ;;;  for special-syntax this must before syntax macro
                          ;;; Don't use eval, because eval call macro-expand-rec!!!
                           ;;; (list 'special p (symbol-value p ))
                           (list 'special p (special-alias p )))  ;; 04.5.7
                   (res   ;;; syntax-macro
                         (set! def (car res))
                         (set! flag (caddr def))
                         (if (or (eq? flag #f) (eqv? flag 0))
                               ;;; p is alias
                             (list 'syntax-macro  (cadr def) p res) 
                             (list 'syntax-macro p (cadr def) res) 
                         )
                      )
                   ((macro? p)   ;;; 05.10.11 New!!!
                       (list 'classic-macro p)  )
                   (else 
                      ;;;(list 'template p (gen-alias p) )
                      ;;;; template may be a function
                        (set! res (gen-alias p))
                        (symbol-value-set res (cons :MACRO_ALIAS  p)) ;;;
                           ;;; 04.5.3  this needs for compiler, p may be defined in
                           ;;; another file
                      (if (symbol-bind? p)
                          ;;;(symbol-value-set res (symbol-value p)) 
                          ;;;;  p may be already alias! let-syntax used
                          ;;;;    in a define-syntax template!
                          ;;;;  04.4.23
                        (begin
                          (set! def #t)
                          (while (and def (symbol-bind? p))
                            (set! def (symbol-value p))
                            (if (and (pair? def) (eq? (car def) :MACRO_ALIAS))
                                (begin
                                  (set! p (cdr def))
                                )
                               (set! def #f)
                            )
                          )
                          (symbol-value-set res (cons :MACRO_ALIAS  p)) 
                        )
                                  ;;;;  04.4.18 for compiler
                      )
                      ;;(format #t "template p ~s res ~s value ~s~%" p res 
                      ;;     (symbol-value res))
                      (list 'template p res)
                   )
             )
           )   )
   )
)
;;;;    alias  should be same in a template!!! 
(define (gen-alias s)
  (let* ((a (assq s *alias-data*)))
     (if a (cdr a)
        (begin
          (set! a (gensym))
          (set! *alias-data* (cons (cons s a) *alias-data*))
          a
        )
     )
))


#|
(define (pat-pair-trans p env)
   (let ((top (car p)) (rest (cdr p))(ans 0))
     (if (pair? rest)
        (if (eq? (car rest) '...)
             (begin
                (inc *pat-level*)
                (set! ans (list '... (pat-trans-common  top env)))
                (dec *pat-level*)
                (cons ans  (pat-trans-common (cdr rest ) env))
             )
             (cons (pat-trans-common  top env) (pat-trans-common rest env))
        )
       (cons (pat-trans-common  top env) (pat-trans-common rest env))
       ;;; (list (pat-trans-common  top env))      wrong for (f . x)!!!
    )
))
|#


#|
(define (pat-vector-trans p env)
   (let ((n (vector-length p)) (res ()) (flag #f)(i 0)(q 0))
      (set! n (- n 1))
      (while (> n 0)
         (push (pat-trans-common  (vector-ref p i) env) res)
         (set! n (- n 1))
         (set! i (+ i 1))
      )
      (if (= n 0)
        (begin
            (set! q (vector-ref p i))
            (if (eq? q '...)
               (begin
                 (set! q (pop res))
                 (push (list '... q) res)
                 (set! flag #t)
                )
                 (push (pat-trans-common  q env) res)
              ) 
          )
      )
      (set! p (cons flag (reverse res)))
      (cons 'vector p)
))
|#
              
   
#|
 (define *macro-key* 'cond)
 (define *literal* (list 'else))

 (pat-trans '(cond (else y ...)) ())

 (pat-trans '(cond (test y ...) clause ...) ())

 (define *macro-key* 'do)
 (pat-trans '(do ((var init step ...) ...)
         (test expr ...)
         command ...)   ())   

 (pat-trans '(do ( #(var init step ...) ...)
         (test expr ...)
         #(foo bug)
         ()
         #()
         command ...)   ())
  (template-trans ' (letrec
       ((loop
           (lambda (var ...)
             (if test
                 (begin
                   (if #f #f)
                   expr ...)
                 (begin command ...
                   (loop (do "step" var step ...)
                       ...)
                 )
              )
            )
           ))
        (loop init ...))      ())
 
|#

