;;;  2010.7.2
;;;

(define (template-trans form)
   (set! form (template-change form))
   (dot-env)
   (init-read-env)
   (template-do form 0)
)

(define (template-change form)
  (let* ((x 0))
      (cond ((symbol? form)
             (set! x (assq form *vars*))
             (if x (list :var form) form)
               )
           ((pair? form)
                 (template-list-change form))
           (else form)
      )
))

(define   (template-list-change form)
  (let* ((P (car form)) (Q (cdr form)))
     (if (and (pair? Q) (eq? (car Q ) '...))
       (begin
         (set! P (list :dot (template-change P)))
         (cons P (template-change (cdr Q)))
       )
      (cons (template-change P)(template-change Q))
    )
))

(define (template-do form level)
   (let* ((x 0))
      (if (pair? form)
         (template-list form  level)
         form
      )
))

(define (template-list form level)
  (let* ((x #t)(y #t)(P (car form)) (Q (cdr form))(res ()))
    (if (and (pair?   P) (eq? (car P) :dot))
        (begin
           (inc level)
           (while x
             (set! x (template-do (cadr P)  level))
             (when x 
                (push x res)
                (set! x  (read-env-next level))
             )
           )
           (dec level)
           (set! x  (template-do Q level))
           (if (= level 0) (read-env-clear))
           (if x
              (append (reverse res) x)
               #f
           )
        )
       (if (eq? P :var)
          (begin
             (set! x (read-env (car Q)))
             (if x (cdr x) #f)
           )
          (if (pair? P)
             (begin
                (set! x  (template-do P level))   ;;;  may be #f if ...
                (if x
                   (begin 
                      (set! y  (template-do Q level))
                      (if (or y (not (pair? Q)))
                         (cons x y) 
                       #f)
                   )
                   #f   ;;; (template-do Q level)
                )
             )
             (begin
                      (set! y  (template-do Q level))
                  (if (or y (not (pair? Q)))
                    (cons (template-do P level) y)
                    #f
                  )
             )
          )
       )
    ) 
))
;;;(define  (template-dot form  level)

     

