;;;; 2010.7.2   Pattern  for Syntax rules
;;;; pat=symbol|constant|list-pat
;;;;  symbol= macro-keyword(M)|Literal(L)|Variable(V)   NOT ...
;;;;  list-pat=(P ...   .  Q )    ->((:dot P) . Q)
;;;;           | (P . Q)     if P,Q are pat.
;;;;    Literal ->  (:literal v)
;;;;    Variable ->  (:var v)
;;;;    state=integer  0,1,2...
;;;;    
;;;;  
(define *key* 'do)
(define Lite ())
(define *vars* ())
(define *max-level* 0)

(define (s->pat  key lite form)
    (set! *key* key)
    (set! *vars* ())
    (set! Lite lite)
    (set! *max-level* 0)
    (form->pat form 0)
)

(define (form->pat  form level)
   (let* ((a 0)(p ())(x 0)(pat ()) (res ()))
       (if (pair? form)
              (pair->pat form level) 
           (if (symbol? form)
                 (cond ((eq? form *key*) form)
                       ((member form Lite) (list :literal form))
                       ((eq? form '...) #f)
                       ((eq? form '_) form)  ;;; R6RS
                       (else
                          (push (cons form level) *vars* ) 
                          (if (> level *max-level*)
                             (set! *max-level* level)
                          )
                           (list :var form level))
                 )
               form   ;;;;  constants or key
           )
       )
))

(define (dot->pat  form level)
   (let* ((P (car form)) (Q (cddr form)))
      (set! P (form->pat P (+ 1 level)))
      (if P
         (begin
            (set! Q (form->pat Q level))
            (if Q  (cons (list :dot P) Q)  #f)
         )
         #f
      )
))

(define  (pair->pat  form level)
   (let* ((P (car form)) (Q (cdr form)))
      (if (and (pair? Q) (eq? (car Q) '...))
            (dot->pat  form level)
         (if (pair? P)
            (begin
               (set! P (pair->pat P level))
               (if P 
                 (begin
                   (set! Q (form->pat Q level)) 
                   (if Q  (cons P Q)  #f)
                  )
                  #f
               )
             )
            (begin
               (set! P (form->pat P level))
               (set! Q (form->pat Q  level))
               (if (and P Q)  (cons P Q) #f)
            )
         )
      )
))
;;;;  match
(define *match-data* ())
(define (s-match pat form)
  (let* ((ans 0))
   (set! *match-data* ())
   (set! ans (pat-match pat form))
   (if ans
     (begin
        (set! *match-data* (reverse  *match-data* ))
        ans
     )
    #f
   )
))

(define (pat-match pat form)
  (let* ((x 0))
    (if (pair? pat)
       (begin
         (set! x (car pat))
         (cond ((eq? x :var)
                      ;;; (push (cons (cadr pat) form) *match-data*)
            ;;;; for empty
                      (push (list (cadr pat) form) *match-data*)
                      form)
               ((eq? x :literal) 
                   (if (eq? form (cadr pat)) form #f)  ;;; need more
                 )
               ((eq? pat '_) form)     ;;; R6RS
               (else 
                  (if (or( pair? form) (null? form))  ;;; form maybe ()
                         (pair-pat-match pat form)
                         #f
                  )
               )
          )
       )
      (if (equal? pat form) form #f)
    )
))
(define (pair-pat-match pat form)
  (let* ((P (car pat))(p 0)(cont #t)(memo 0)(d 0))
     (if (and (pair? P) (eq? (car P) :dot))
        (begin
           (set! p (cadr P))
           (set! memo *match-data*)
           (set! *match-data* ())
           (while (and cont (pair? form))
              (if (pat-match p (car form))
                 (set! form (cdr form))
                 (set! cont #f)
              )
           )
           (set!  d (reverse *match-data* ))
           ;;;(set! *match-data* (cons (cons (take-var p) d) memo))
           (set! *match-data* (cons (cons  p d) memo))
          (pat-match (cdr pat) form)
        )
          (if (pat-match P (car form))
             (pat-match (cdr pat)(cdr form))
             #f
          ) 
     )
))
#|
(define (take-var p)
  (let* ((x 0)(y 0))
   (if (pair? p)
      (if (eq? (car p) :var)
             p
           (begin
              (set! x (take-var (car p)))
              (set! y (take-var (cdr p)))
              (if x
                 (if y
                    (cons x y)
                    (cons x ())
                 )
                (if y
                      (cons () y)
                      #f
                )
             )
           )
      )
     #f
  )
))
|#
  
