;;;;  2010.8.11
;;;;     On Boot ss 
;;;;     minimum set of syntax-expand!
;;;;      We will delete macro
;;;;     syntax-lambda  is only macro for ss V2.0
;;;;;

(in-package "macro")
(define *local-env* ())

;;;;  only for global macro
(define (get-macro  key)
 (let* ((d ()))
    (if (symbol? key)
      (if (symbol-bind?  key) (set! key (symbol-value key))) 
    )
    (if (syntax-lambda? key)
        key
        #f
    )
))

(define macro? get-macro)

(define (syntax-expand f env)
   (let* ((memo *local-env*))
    (set! *local-env* env)
    (set! f (syntax-ex f ))
    (set! *local-env* memo)
    f
))

(define (syntax-ex f)
  (if (pair? f)
        (syntax-ex-pair f)
       f
  )
)


;;;;  
(define (syntax-ex-pair  f )
  (let* ( (top (car f))(x 0) )
       (if   (pair? top)  ;;; ((lambda  ...))  may exists macro in the form
         (begin    (set! x (syntax-ex top ))
                 (if (not (equal? top x))
                     (syntax-ex-pair  (cons x (cdr f) ))
                     (syntax-ex-args f )
                 )
         )
         (if (special? top)
            (begin
               ;;;(format #t "syntax-ex-pair special  ~s ~%" top )
               (set! top (special? top ))
               (special-ex top f)
            )
            (if (symbol? top)
                (syntax-ex-symbol-pair f)  
                (if (syntax-lambda? top)
                     (syntax-ex (syntax-lambda-ex f top))
                  ;;; we assume function call
                     (syntax-ex-args f )
               )
            )
        )
      )
))

(define (syntax-ex-symbol-pair  f )
  (let* ( (top (car f))(x 0)(v 0))
          ;;; top is symbol 
       (set! x (get-macro top ))  ;;;new
       (if  (syntax-lambda? x)
              (syntax-ex (syntax-lambda-ex f x))
              (syntax-ex-args  f )
       )
))

(define (syntax-ex-args  f  )
  (letrec  ((x 0) (y 0)(res ()) (args (cdr f))(ans #f)   ;;; while loop
     (loop (lambda () (if  (pair? args) (begin
         (set! x (car args))
         (set! y (syntax-ex x ))
         (set! res (cons y  res) )
        ;;;(format #t "ex-args:~s ~s~%" x y)
         (if (not (equal? x y)) (set! ans #t))
         (set! args (cdr args))
         (loop) )))  ))
      (set! res (cons (car f) ()))
     (loop)
       ;;; (format #t "ex-args res:~s  args ~s loop ~s ~%" res args loop)
     (if ans
         (begin
            (set! res (cons args  res) )   ;;;  f may be dot-list
           (syntax-ex (apply list* (reverse res)))
         )
          f
     )
))

(define  (let*-arg-ex  args  )
  (letrec  ((x 0) (res ()) (narg ())(init 0)   ;;; while loop
    (loop (lambda () (if  (pair? args)
       (begin
         (set! x (car args))
         (set! init (cadr x))
         (set! x (car x))
         (set! init (syntax-ex init ))
         (set! narg  (cons (list x init) narg))
         (set! args (cdr args))
         (loop)
         )  ) ))     )
      (loop)
    (reverse narg) 
))

(define (define-exp f)
   (let* (( g  (cddr f)) ( args (cadr f)))
             (if (pair? args)
                  (begin
                    (set! g (list* 'lambda (cdr args) g))
                    (set! args (car args))
                  )
                 (if (null? (cdr g))
                    (set! g (car g)) ;;; (define x g)
                    (error 4443 f)
                 )
             )
             (set! g (syntax-ex g))
       (list (car f)  args g)
))

(define (let-exp f)
   (let* (( args (let*-arg-ex  (cadr f) ))
            (g (syntax-ex-args (cdr f)  )))
         (cons (car f) (cons args (cdr g)))
))

(define  (special-ex top f )
  (let* ((args 0)(g 0))
   (if (memq  top '(let* let letrec))
       (let-exp f)
      (if (eq? top 'define)   
              (define-exp f)
         (if(eq?  top 'set!) 
            (begin
             (set! g (syntax-ex (caddr f) ))
             (list (car f) (cadr f) g)
            )
            (if (memq top '(quote INLINE))  ;;; V2.0
             f
             (if (memq top '(begin if apply))
                 (syntax-ex-args f  )
                (if (eq? top 'lambda)
                  (begin
                    (set! g (syntax-ex-args (cdr f)  ))
                    (cons (car f) g)
                  )
                 (error 4444 f)
                )
             )
           )
        )
     )
   )
))
;;;;  
(define (syntax-lambda-ex f def )
  (let* ((pat 0)(env ())(rule 0)(rules 0)(ans #f))
    ;;;;   sys-eval defined 2010.8.12  it does not call expand
    ;;;;      allow only basic syntax!
    (sys-eval (list   def (list quote f)) ())
   #|
    (set! f (eval (list  (<-syntax  def) (list quote f)) ()))
    (->syntax def)  ;;;; This need. because, eval call syntax-expand
                    ;;;;  and causes infinity loop!
   |#
))

#|
(export '( syntax-rules macro-update macro-symbols macro? ))
(export 'macro-expand-1)
(use-package "macro" "ss")
|#

(set! macro-expand-rec syntax-expand)
#|
(define define-syntax
   (->syntax  (lambda (x)
       `(define ,(cadr x)
       (->syntax
           (let* ((dummy (car ',x)) (para (cdr ',x)) (key (car para))
                 (exp (cdr para)))
           ,@exp) )
       )
     )
   )
)
|#
(define define-syntax
   (->syntax  (lambda (x)
      (let* ((dummy (car x)) (para (cdr x)) (key (car para)) (exp (cdr para)))
      #|
       ;;;;  quasiquote is macrosubr!!!  We can't use here
       `(define ,key
          (->syntax ,(car exp) ))
      |#
;;;;   above is extended in the following
(cons (quote define) (cons key (cons (cons (quote ->syntax) (cons (car exp) ())) ())))
      )
     )
   )
)
;;;***  see qquote.c    ****
;;;;     quasiquote   is Now transformer!
;;;      must delete old quasuquote
#|
(define-syntax quasiquote
   (lambda(x)
      (lambda-quote (cadr x)) )
)
|#
(load "quasi-syntax")

;;;;  (define-macro (f args ...) body ...)  as a syntax
(define-syntax define-macro
   (lambda (x)
    #|
    (let* ((f (gensym)))
     `(define-syntax  ,(car (cadr x))
          (let* ((,f (lambda ,(cdr (cadr x)) ,@(cddr x))))
            (lambda (exp)
               (apply  ,f (cdr exp))
             )
          )
      )
    )
   |#
;;;;   above is extended in the following
 (let* ((f (gensym)))
(cons (quote define-syntax) (cons (car (cadr x)) (cons (cons (quote let*) (cons (cons (cons  f (cons (cons (quote lambda) (cons (cdr (cadr x)) (cddr x))) ())) ()) (cons (cons (quote lambda) (cons (cons (quote exp) ()) (cons (cons (quote apply) (cons  f (cons (cons (quote cdr) (cons (quote exp) ())) ()))) ()))) ()))) ())))
)))

(export '(define-syntax define-macro syntax-expand macro? _ ))
(use-package "macro" "ss")
(set! macro-expand-rec syntax-expand)


#|
(define-macro (trace . funcs)
  (let* ((fun 0))
    (if (pair? funcs)
        (begin
             (set! fun (car funcs))
             #|
              (if (eq? fun 'apply)
                     (set! apply trace-apply) ;;; see lib.scm
              )
             |#

          `(begin
                (trace-f ',fun  ,fun)
                (trace ,@(cdr funcs))
           )
        )
        '*trace*
    )
))
|#
