;;;  vm-list-final.ss
;;; 07.9.2
;;;  final  of compiler output
;;;  optimize will be support in the future
;;;   list version
;;;   
;;;  LABEL  deleted
;;;  Block , Blockend is changed
;;;   revised 2010.4.26

;;;  JMP n is changed to jump size


(define (final s)
  (let* ((x 0)(op 0)(ind 0)(len (length s))
          (OBJ ())
          (LABELS  ()))
    (while (pair? s)
       (set! x (pop s))
       (set! op (car x))
       (if (eq? op 'LABEL)
               (push (cons (cadr x) (take-label s)) LABELS) 
             (push x OBJ)  
       )
    )
   (op-final (reverse OBJ) LABELS)
))
;;;     (LABEL 1)(LABEL 2)  S ...  =>   S ...
(define (take-label s)
  (let*  ((cont #t))
   (while (and cont (pair? s))
      (if (eq? (caar s) 'LABEL)
            (set! s (cdr s))
            (set! cont #f)
      )
   )
   s
))

(define (op-final s LABELS)
  (let* ((op 0) (x 0) (OBJ ()))
   ;;;(format #t "op ~s~%" op )
   (while (pair? s)
       (set! x (pop s))
       (set! op (car x))
       (cond ( (eq? op 'JMP)
                (set! x (list 'JMP2 (jmp-count s (cadr x) LABELS)))  )
             ((eq? op 'IF-FALSE)
                (set! x (list 'FALSE2 (jmp-count s (cadr x) LABELS)))  )
             ((or (eq? op 'LAMBDA) (eq? op 'MACRO))
                 (set! x (list op (final (cadr x)))) )
             ((eq? op 'BLOCK)
                 (set! x '(Push-ENV)))
             ((eq? op 'BLOCKEND)
                 (set! x '(Pull-ENV)))
             ((eq? op 'IMM)
                 (set! x (F-IMM x)))
             (else )
         )
        (push x OBJ)
   )
  (reverse OBJ)
))

(define (F-IMM  form)
  (let* ((val (cadr form)))
       (cond ((eq? val UNDEF) '(IMM-undef))
             ((eq? val #t)  '(IMM-t))
             ((eq? val #f)  '(IMM-f))
             ((eq? val ())  '(IMM-null))
             ((eq? val 0)  '(IMM-0))
             ((eq? val 1)  '(IMM-1))
             (else  form)
        )
    )
)

    

(define (jmp-count s n LABELS)
  (let* ((dest (assq n LABELS)))
    (if dest
      (if (null? (cdr dest))
          (length s)
          (jmp-count-aux 0 s (cadr dest))
      )
      (error 999)
    )
))

(define  (jmp-count-aux n s dest)
   ;;;(format #t "jmp-count-aux ~s ~s ~s ~%" n (car s) dest)
   (if (eq? (car s)  dest)
       n
     (if (null? s)
        (error 998)
           (jmp-count-aux (+ n 1) (cdr s) dest)
     )
   )
)

