;;; usage:  (get-file-name)
;;;         (get-file-name ".sgf")
;;;  if no-file then #f
;;;  if no selection   ()  is returned
;;;;
(define *file-kakutei* "")
(define *dir* ())
(define (get-file-name . ext)
  (let ((n-files 0) (dir "") (f-ext ""))
    (toplevel '.dir)
     (set!  *file-kakutei* "")
    (and  (pair? ext) (string? (car ext))
          (set! f-ext (car ext)) )

    (wm 'title  .dir  (tk-conc "File Select window  " f-ext))
    (wm 'geometry .dir "300x200+80+80")
     (listbox '.dir.lb 
        :yscrollcommand
                  (lambda l (apply  .dir.yscroll 'set l))
       :width 25 :height 8)
     (scrollbar  '.dir.yscroll  :orient 'vertical
                 :command
                    (lambda l (apply  .dir.lb  'yview l))
       )
     (grid  .dir.lb   .dir.yscroll  :sticky 'nes)
     (label '.dir.name :text "file name" :width 25  :height 2)
     (button '.dir.ok :text "OK" :width 10 :height 2 
               :command (lambda () (destroy .dir)) )
     (grid .dir.name .dir.ok)
     ;(pack .dir.lb)

     (set!  dir (exec "ls -1Ap"))
     (set!  dir (split-string dir ))
     (set! *dir* ())
     (do ((x ()) (i 0) (dirs dir))
          ((null? dirs) (set! n-files i))
         (set! x (pop dirs))
         (when  (string-last? x f-ext)
           (.dir.lb 'insert 'end  x)
           (push x *dir*)
            (incf i)
         )
      )
     (set! *dir* (reverse *dir*))
     (if (= n-files 0)
       (begin
         (.dir.name 'configure :text "No files")
            ; (after 2000)
         (destroy .dir)
         #f
        )
       (begin
          (bind '.dir.lb   "<Button-1>" (lambda (x y)
                         ;(format #t "~a ~a~% " x y)
                         (get-num  x y)
                          )
          )
        (bind .dir.name   "<Return>" (lambda () (destroy .dir)) )
         (tkwait 'window .dir )
         *file-kakutei*
       )
    )
))
(define (get-num x y)
   (let ((i  (.dir.lb  'nearest y  ))
            )
     (set! x  (list-ref *dir* i))
     (.dir.name 'configure :text x)
     (set! *file-kakutei* x)
)) 

(define (string-last? str ext)
  (let ((i 0))
    (if (equal? ext "")
         #t
      (begin
        (set! i  (string-index ext str))  ;;; may be #f
        (if i
          (= (string-length str) (+  i  (string-length ext)))
          #f
          )
      )
    )
)) 

;(define (get-num x y)
;  (let ((h (winfo 'height .dir.lb)) 
;            (range (.dir.lb 'yview))   )
;        
;    (set! y (+ (car range) (* (- (cadr range) (car range)) (/ y h))))
;     (write y)
;     (write #\space)
;     (set! y  (floor (* y *n-files*)))
;     (newline)
;     (set! x  (list-ref *dir* y))
;     (.dir.name 'configure :text x)
;     (set! *file-name* x)
;))
    

