;;; usage:  (get-save-file)
;;;         (get-save-file ".sgf")
;;;  if cancel then  then #f
;;; 
;;;;
(define *file-kakutei* "")
(define *dir* ())
(define (get-save-file . ext)
  (let ((n-files 0) (dir "") (f-ext ""))
    (toplevel '.dir)
     (set!  *file-kakutei* "")
    (and  (pair? ext) (string? (car ext))
          (set! f-ext (car ext)) )

    (wm 'title  .dir  (tk-string "Input File Name for Save  " f-ext))
    (wm 'geometry .dir "300x250+80+80")
     (label  '.dir.files :text "Exists files")
     (grid .dir.files)
     (listbox '.dir.lb 
        :yscrollcommand
                  (lambda l (apply  .dir.yscroll 'set l))
       :width 25 :height 8)
     (scrollbar  '.dir.yscroll  :orient 'vertical
                 :command
                    (lambda l (apply  .dir.lb  'yview l))
       )
     (grid  .dir.lb   .dir.yscroll  :sticky 'nes)
     (label '.dir.mesg :text "Input file name")
     (entry  '.dir.name   :width 25 ) 
                ;;; :textvariable  '*file-kakutei* )
      (.dir.name 'insert  'insert    f-ext)
     (button '.dir.ok :text "OK" :width 10 :height 2 
               :command (lambda () (file-exists-check) )  )
      (grid .dir.mesg)
     (grid .dir.name .dir.ok)
     ;(pack .dir.lb)

     (set!  dir (exec "ls -1Ap"))
     (set!  dir (split-string dir ))
     (set! *dir* ())
     (do ((x ()) (i 0) (dirs dir))
          ((null? dirs) (set! n-files i))
         (set! x (pop dirs))
         (when  (string-last? x f-ext)
           (.dir.lb 'insert 'end  x)
           (push x *dir*)
            (inc i)
         )
      )
     (set! *dir* (reverse *dir*))
      (if (> n-files 0)
          (bind '.dir.lb   "<Button-1>" (lambda (x y)
                         ;(format #t "~a ~a~% " x y)
                         (set-entry  x y)
                          )
           )
       )
     ;(bind .dir.name "<Return>" (lambda () (file-exists-check) )  )
     (tkwait 'window .dir )
      *file-kakutei*
))
(define (file-exists-check)
   (set! *file-kakutei* (.dir.name 'get))
  (if  (file-exists? *file-kakutei*)
    (begin
       (.dir.mesg 'configure :text "Input another name")
       (set! *file-kakutei* #f)
    )
    (destroy .dir)
  )
)

(define (set-entry x y)
   (let ((i  (.dir.lb  'nearest y  ))
            )
     (set! x  (list-ref *dir* i))
     (.dir.name 'delete 0 'end)
     (.dir.name 'insert  'insert    x)
     (set! *file-kakutei* x)
)) 

(define (string-last? str ext)
  (let ((i 0))
    (if (equal? ext "")
         #t
      (begin
        (set! i  (string-index ext str))  ;;; may be #f
        (if i
          (= (string-length str) (+  i  (string-length ext)))
          #f
          )
      )
    )
))

    

