#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <unistd.h>

//#define SIZE 40
#define SIZE 10
//#define J_H 0.45
#define J_H 2.45
#define COUNT 1000
#define DEBUG 0

double urandom()
{
	return (double)rand() / ((double)RAND_MAX + 1.0);
}

//1 or -1を返す
double nrandom()
{
	if((int)(2*(double)rand() / ((double)RAND_MAX + 1.0)) == 0)
		return -1;
	else
		return 1;
}
//初期設定
void initialization(int data[SIZE][SIZE])
{
	int i, j;

	for(i=0; i<SIZE; i++){
		for(j=0; j<SIZE; j++){
			data[i][j] = nrandom();
		}
	}
}

//状態遷移
void state_transition(int data[SIZE][SIZE])
{
	int i,j,s;
	int cnt1=0,cnt2=0,cnt3=0;
	double x;
	int tmp[SIZE][SIZE];

	for(i=0; i<SIZE; i++){
		for(j=0; j<SIZE; j++){
			s=0;
			if(i != 0)
				s+=data[i-1][j];
			if(i != SIZE-1)
				s+=data[i+1][j];
                        if(j != 0)
                                s+=data[i][j-1];
                        if(j != SIZE-1)
                                s+=data[i][j+1];
			x =urandom();
                 //printf("s=%d data=%d\n",s,data[i][j]);
			//printf("%f\n", x);
			if(signbit(s) != signbit(data[i][j])){
				tmp[i][j]=-1*data[i][j];
                                cnt1++;
                        }
			else if((exp(-1*J_H*s*data[i][j])) > x){
				tmp[i][j]=-1*data[i][j];
			cnt2++;
			//printf("%d\n", cnt);
			}else{
				tmp[i][j]=data[i][j];
                           cnt3++;
                       }
		}
	}
#ifdef DEBUG
	printf("cnt1=%d  cnt2=%d cnt3=%d\n", cnt1,cnt2,cnt3);
#endif
	for(i=0; i<SIZE; i++){
		for(j=0; j<SIZE; j++){
			data[i][j] = tmp[i][j];
		}
	}
}

void print(int data[SIZE][SIZE])
{
	int i,j;

	for(i=0; i<SIZE; i++){
		for(j=0; j<SIZE; j++){
			if(data[i][j] == 1)
                        	printf("⬛️ ");
			else
				printf("  ");
		}
		printf("\n");
	}
}

int main()
{
	srand((unsigned int)time(NULL));
	int n;
	int s[SIZE][SIZE];
	
	initialization(s);

	for(n=0; n<10; n++){
		state_transition(s);
		print(s);
		printf("\n\n");
		usleep(600000);
	}

	return 0;
}
