;;;Ising model simulation
;;;   04.1.15
;;;
(define MX 50)
(define MXP (+ MX 1))
(define MXP2 (+ MX 2))
(define MD 5)
(define B  0.4)
(define LS (* MX MX))
(define MS 30)
(define X (make-matrix MXP2 MXP2 1))  
(define PB (make-vector 9))

(define (make-prob b)
  (do ((k 0 (+ k 1)))
    ((= k 9))
    (vector-set! PB k
       (/ (exp (* b (- k 4)))
          (+ (exp (* b (- k 4))) (exp (* (- b) (- k 4))))))
  )
)

;;;  make boad
(define top (toplevel '.ising))

(define (button-name i j)
    (tk-name  ".ising.f" i ".b" j))

(define (init-screen)
   (let ((x 0) (y 0)  (n 0)  (bt 0) (fr 0))
     (do
         ((i 1 (+ i 1)))
         ((= i MXP))
         (set! fr (tk-name ".ising.f" i))
          (frame fr)
         (pack fr :side 'top) 
        (do
          ((j 1 (+ j 1)))
          ((= j MXP))
          (set! bt (button-name  i j))
          (format #t "~s ~%" bt)
          (button bt :height 5 :width 5 :bitmap 'gray12 :bg 'black
                        :relief  'raise )
          (pack bt :in fr :side 'left)
         )
     )
))

(define (markdot i j s)
  (if (= s 1)
     (set! s 'white)
     (set! s 'black)
  )
  (funcall (button-name i j) 'configure :bg s ) 
)

(init-screen)

(define (init-ising)
  (let ((p 0)(s 0))
    (do ((i 1 (+ i 1)))
      ((= i MXP))
     (do ((j 1 (+ j 1)))
         ((= j MXP))
         (set! p (random))
         (if (< p 0.5)
            (set! s 1)
            (set! s -1)
          )
         (matrix-set! X i j s)
         (markdot i j s)
      )
    )
  (update)
))

;;;  main
(define (int-floor x)
  (inexact->exact (floor x))
)

(define (sim)
  (let ((i 0)(j 0)(d 0)(p 0)(s 0))
    (do ((n 0 (+ n 1)))
        ((= n LS))
        (set! i (+ (int-floor (* MX (random))) 1))
        (set! j (+ (int-floor (* MX (random))) 1))
        ;;;(format #t "i ~s j ~s~%" i j)
        (set!  d (matrix-ref X (- i 1) j))
        (set!  d (+ d (matrix-ref X (+ i 1) j)))
        (set!  d (+ d (matrix-ref X  i  (- j 1))))
        (set!  d (+ d (matrix-ref X  i  (+ j 1))))
        (set! d (+ d 4))
        (set! p (random))
        (if (<  p (vector-ref PB d))
            (set! s 1)
            (set! s -1)
        )
       (matrix-set! X i j s)
       (markdot i j s)
       (update)
    )
))

   
;;; start
(define (start b)
  (init-ising)
  (make-prob b)
  (do ((i 0 (+ i 1)))
     ((= i MS))
     (sim)
       ;;(after 100)
  )
)

(start B)
       
       
   
