;;; netcomm.ss  
;;;   simple communicate with C program with Net
;;;  2004.7.26

(define  *net-pipe*  (netport 51000))
(define *listen-pipe*  (socket-listen *net-pipe*))
(define client-port  (socket-connect *net-pipe*))
(define server-port  (socket-accept  *listen-pipe*))

(define (waitp pid )
   (if (process-exited? pid)
         (close-port client-port) ;;; then we will get eof-object!!!
         (after 500 (lambda ()(waitp pid)))
  )
)

(define (do-input-line  proc)
   (let ((x ()))
     (while  (not (eof-object? x))
        (if (char-ready?)
             (begin
                (set! x (read-line))
                (if (not (eof-object? x)) (proc x))
             )
             (update)
         )
     )
))

(define pid  (redirect '(run-process "ls" "-la" ) #f client-port  #f))
(waitp  pid)

(redirect '(do-input-line  (lambda(x) (format #t "~a~%" x))) 
        server-port #f #f)

 (close-port client-port)
 (close-port server-port)
 (close-port *listen-pipe*)


